// A Bison parser, made by GNU Bison 3.0.4.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

// Take the name prefix into account.
#define yylex   parser4_lex

// First part of user declarations.

#line 39 "dhcp4_parser.cc" // lalr1.cc:404

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

#include "dhcp4_parser.h"

// User implementation prologue.

#line 53 "dhcp4_parser.cc" // lalr1.cc:412
// Unqualified %code blocks.
#line 34 "dhcp4_parser.yy" // lalr1.cc:413

#include <dhcp4/parser_context.h>

#line 59 "dhcp4_parser.cc" // lalr1.cc:413


#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K].location)
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (/*CONSTCOND*/ false)
# endif


// Suppress unused-variable warnings by "using" E.
#define YYUSE(E) ((void) (E))

// Enable debugging if requested.
#if PARSER4_DEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << std::endl;                  \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yystack_print_ ();                \
  } while (false)

#else // !PARSER4_DEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YYUSE(Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void>(0)
# define YY_STACK_PRINT()                static_cast<void>(0)

#endif // !PARSER4_DEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

#line 14 "dhcp4_parser.yy" // lalr1.cc:479
namespace isc { namespace dhcp {
#line 145 "dhcp4_parser.cc" // lalr1.cc:479

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
  Dhcp4Parser::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr = "";
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              // Fall through.
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }


  /// Build a parser object.
  Dhcp4Parser::Dhcp4Parser (isc::dhcp::Parser4Context& ctx_yyarg)
    :
#if PARSER4_DEBUG
      yydebug_ (false),
      yycdebug_ (&std::cerr),
#endif
      ctx (ctx_yyarg)
  {}

  Dhcp4Parser::~Dhcp4Parser ()
  {}


  /*---------------.
  | Symbol types.  |
  `---------------*/



  // by_state.
  inline
  Dhcp4Parser::by_state::by_state ()
    : state (empty_state)
  {}

  inline
  Dhcp4Parser::by_state::by_state (const by_state& other)
    : state (other.state)
  {}

  inline
  void
  Dhcp4Parser::by_state::clear ()
  {
    state = empty_state;
  }

  inline
  void
  Dhcp4Parser::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

  inline
  Dhcp4Parser::by_state::by_state (state_type s)
    : state (s)
  {}

  inline
  Dhcp4Parser::symbol_number_type
  Dhcp4Parser::by_state::type_get () const
  {
    if (state == empty_state)
      return empty_symbol;
    else
      return yystos_[state];
  }

  inline
  Dhcp4Parser::stack_symbol_type::stack_symbol_type ()
  {}


  inline
  Dhcp4Parser::stack_symbol_type::stack_symbol_type (state_type s, symbol_type& that)
    : super_type (s, that.location)
  {
      switch (that.type_get ())
    {
      case 159: // value
      case 163: // map_value
      case 201: // socket_type
      case 211: // db_type
      case 288: // hr_mode
      case 421: // ncr_protocol_value
      case 429: // replace_client_name_value
        value.move< ElementPtr > (that.value);
        break;

      case 145: // "boolean"
        value.move< bool > (that.value);
        break;

      case 144: // "floating point"
        value.move< double > (that.value);
        break;

      case 143: // "integer"
        value.move< int64_t > (that.value);
        break;

      case 142: // "constant string"
        value.move< std::string > (that.value);
        break;

      default:
        break;
    }

    // that is emptied.
    that.type = empty_symbol;
  }

  inline
  Dhcp4Parser::stack_symbol_type&
  Dhcp4Parser::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
      switch (that.type_get ())
    {
      case 159: // value
      case 163: // map_value
      case 201: // socket_type
      case 211: // db_type
      case 288: // hr_mode
      case 421: // ncr_protocol_value
      case 429: // replace_client_name_value
        value.copy< ElementPtr > (that.value);
        break;

      case 145: // "boolean"
        value.copy< bool > (that.value);
        break;

      case 144: // "floating point"
        value.copy< double > (that.value);
        break;

      case 143: // "integer"
        value.copy< int64_t > (that.value);
        break;

      case 142: // "constant string"
        value.copy< std::string > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    return *this;
  }


  template <typename Base>
  inline
  void
  Dhcp4Parser::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);
  }

#if PARSER4_DEBUG
  template <typename Base>
  void
  Dhcp4Parser::yy_print_ (std::ostream& yyo,
                                     const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YYUSE (yyoutput);
    symbol_number_type yytype = yysym.type_get ();
    // Avoid a (spurious) G++ 4.8 warning about "array subscript is
    // below array bounds".
    if (yysym.empty ())
      std::abort ();
    yyo << (yytype < yyntokens_ ? "token" : "nterm")
        << ' ' << yytname_[yytype] << " ("
        << yysym.location << ": ";
    switch (yytype)
    {
            case 142: // "constant string"

#line 218 "dhcp4_parser.yy" // lalr1.cc:636
        { yyoutput << yysym.value.template as< std::string > (); }
#line 364 "dhcp4_parser.cc" // lalr1.cc:636
        break;

      case 143: // "integer"

#line 218 "dhcp4_parser.yy" // lalr1.cc:636
        { yyoutput << yysym.value.template as< int64_t > (); }
#line 371 "dhcp4_parser.cc" // lalr1.cc:636
        break;

      case 144: // "floating point"

#line 218 "dhcp4_parser.yy" // lalr1.cc:636
        { yyoutput << yysym.value.template as< double > (); }
#line 378 "dhcp4_parser.cc" // lalr1.cc:636
        break;

      case 145: // "boolean"

#line 218 "dhcp4_parser.yy" // lalr1.cc:636
        { yyoutput << yysym.value.template as< bool > (); }
#line 385 "dhcp4_parser.cc" // lalr1.cc:636
        break;

      case 159: // value

#line 218 "dhcp4_parser.yy" // lalr1.cc:636
        { yyoutput << yysym.value.template as< ElementPtr > (); }
#line 392 "dhcp4_parser.cc" // lalr1.cc:636
        break;

      case 163: // map_value

#line 218 "dhcp4_parser.yy" // lalr1.cc:636
        { yyoutput << yysym.value.template as< ElementPtr > (); }
#line 399 "dhcp4_parser.cc" // lalr1.cc:636
        break;

      case 201: // socket_type

#line 218 "dhcp4_parser.yy" // lalr1.cc:636
        { yyoutput << yysym.value.template as< ElementPtr > (); }
#line 406 "dhcp4_parser.cc" // lalr1.cc:636
        break;

      case 211: // db_type

#line 218 "dhcp4_parser.yy" // lalr1.cc:636
        { yyoutput << yysym.value.template as< ElementPtr > (); }
#line 413 "dhcp4_parser.cc" // lalr1.cc:636
        break;

      case 288: // hr_mode

#line 218 "dhcp4_parser.yy" // lalr1.cc:636
        { yyoutput << yysym.value.template as< ElementPtr > (); }
#line 420 "dhcp4_parser.cc" // lalr1.cc:636
        break;

      case 421: // ncr_protocol_value

#line 218 "dhcp4_parser.yy" // lalr1.cc:636
        { yyoutput << yysym.value.template as< ElementPtr > (); }
#line 427 "dhcp4_parser.cc" // lalr1.cc:636
        break;

      case 429: // replace_client_name_value

#line 218 "dhcp4_parser.yy" // lalr1.cc:636
        { yyoutput << yysym.value.template as< ElementPtr > (); }
#line 434 "dhcp4_parser.cc" // lalr1.cc:636
        break;


      default:
        break;
    }
    yyo << ')';
  }
#endif

  inline
  void
  Dhcp4Parser::yypush_ (const char* m, state_type s, symbol_type& sym)
  {
    stack_symbol_type t (s, sym);
    yypush_ (m, t);
  }

  inline
  void
  Dhcp4Parser::yypush_ (const char* m, stack_symbol_type& s)
  {
    if (m)
      YY_SYMBOL_PRINT (m, s);
    yystack_.push (s);
  }

  inline
  void
  Dhcp4Parser::yypop_ (unsigned int n)
  {
    yystack_.pop (n);
  }

#if PARSER4_DEBUG
  std::ostream&
  Dhcp4Parser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  Dhcp4Parser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  Dhcp4Parser::debug_level_type
  Dhcp4Parser::debug_level () const
  {
    return yydebug_;
  }

  void
  Dhcp4Parser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // PARSER4_DEBUG

  inline Dhcp4Parser::state_type
  Dhcp4Parser::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - yyntokens_] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - yyntokens_];
  }

  inline bool
  Dhcp4Parser::yy_pact_value_is_default_ (int yyvalue)
  {
    return yyvalue == yypact_ninf_;
  }

  inline bool
  Dhcp4Parser::yy_table_value_is_error_ (int yyvalue)
  {
    return yyvalue == yytable_ninf_;
  }

  int
  Dhcp4Parser::parse ()
  {
    // State.
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[3];

    /// The return value of parse ().
    int yyresult;

    // FIXME: This shoud be completely indented.  It is not yet to
    // avoid gratuitous conflicts when merging into the master branch.
    try
      {
    YYCDEBUG << "Starting parse" << std::endl;


    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, yyla);

    // A new symbol was pushed on the stack.
  yynewstate:
    YYCDEBUG << "Entering state " << yystack_[0].state << std::endl;

    // Accept?
    if (yystack_[0].state == yyfinal_)
      goto yyacceptlab;

    goto yybackup;

    // Backup.
  yybackup:

    // Try to take a decision without lookahead.
    yyn = yypact_[yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token: ";
        try
          {
            symbol_type yylookahead (yylex (ctx));
            yyla.move (yylookahead);
          }
        catch (const syntax_error& yyexc)
          {
            error (yyexc);
            goto yyerrlab1;
          }
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.type_get ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.type_get ())
      goto yydefault;

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", yyn, yyla);
    goto yynewstate;

  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;

  /*-----------------------------.
  | yyreduce -- Do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_(yystack_[yylen].state, yyr1_[yyn]);
      /* Variants are always initialized to an empty instance of the
         correct type. The default '$$ = $1' action is NOT applied
         when using variants.  */
        switch (yyr1_[yyn])
    {
      case 159: // value
      case 163: // map_value
      case 201: // socket_type
      case 211: // db_type
      case 288: // hr_mode
      case 421: // ncr_protocol_value
      case 429: // replace_client_name_value
        yylhs.value.build< ElementPtr > ();
        break;

      case 145: // "boolean"
        yylhs.value.build< bool > ();
        break;

      case 144: // "floating point"
        yylhs.value.build< double > ();
        break;

      case 143: // "integer"
        yylhs.value.build< int64_t > ();
        break;

      case 142: // "constant string"
        yylhs.value.build< std::string > ();
        break;

      default:
        break;
    }


      // Compute the default @$.
      {
        slice<stack_symbol_type, stack_type> slice (yystack_, yylen);
        YYLLOC_DEFAULT (yylhs.location, slice, yylen);
      }

      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
      try
        {
          switch (yyn)
            {
  case 2:
#line 227 "dhcp4_parser.yy" // lalr1.cc:859
    { ctx.ctx_ = ctx.NO_KEYWORD; }
#line 680 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 4:
#line 228 "dhcp4_parser.yy" // lalr1.cc:859
    { ctx.ctx_ = ctx.CONFIG; }
#line 686 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 6:
#line 229 "dhcp4_parser.yy" // lalr1.cc:859
    { ctx.ctx_ = ctx.DHCP4; }
#line 692 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 8:
#line 230 "dhcp4_parser.yy" // lalr1.cc:859
    { ctx.ctx_ = ctx.INTERFACES_CONFIG; }
#line 698 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 10:
#line 231 "dhcp4_parser.yy" // lalr1.cc:859
    { ctx.ctx_ = ctx.SUBNET4; }
#line 704 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 12:
#line 232 "dhcp4_parser.yy" // lalr1.cc:859
    { ctx.ctx_ = ctx.POOLS; }
#line 710 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 14:
#line 233 "dhcp4_parser.yy" // lalr1.cc:859
    { ctx.ctx_ = ctx.RESERVATIONS; }
#line 716 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 16:
#line 234 "dhcp4_parser.yy" // lalr1.cc:859
    { ctx.ctx_ = ctx.OPTION_DEF; }
#line 722 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 18:
#line 235 "dhcp4_parser.yy" // lalr1.cc:859
    { ctx.ctx_ = ctx.OPTION_DATA; }
#line 728 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 20:
#line 236 "dhcp4_parser.yy" // lalr1.cc:859
    { ctx.ctx_ = ctx.HOOKS_LIBRARIES; }
#line 734 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 22:
#line 237 "dhcp4_parser.yy" // lalr1.cc:859
    { ctx.ctx_ = ctx.DHCP_DDNS; }
#line 740 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 24:
#line 245 "dhcp4_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ElementPtr(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location))); }
#line 746 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 25:
#line 246 "dhcp4_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ElementPtr(new DoubleElement(yystack_[0].value.as< double > (), ctx.loc2pos(yystack_[0].location))); }
#line 752 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 26:
#line 247 "dhcp4_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ElementPtr(new BoolElement(yystack_[0].value.as< bool > (), ctx.loc2pos(yystack_[0].location))); }
#line 758 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 27:
#line 248 "dhcp4_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ElementPtr(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location))); }
#line 764 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 28:
#line 249 "dhcp4_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ElementPtr(new NullElement(ctx.loc2pos(yystack_[0].location))); }
#line 770 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 29:
#line 250 "dhcp4_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ctx.stack_.back(); ctx.stack_.pop_back(); }
#line 776 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 30:
#line 251 "dhcp4_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ctx.stack_.back(); ctx.stack_.pop_back(); }
#line 782 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 31:
#line 254 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // Push back the JSON value on the stack
    ctx.stack_.push_back(yystack_[0].value.as< ElementPtr > ());
}
#line 791 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 32:
#line 259 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // This code is executed when we're about to start parsing
    // the content of the map
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.push_back(m);
}
#line 802 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 33:
#line 264 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // map parsing completed. If we ever want to do any wrap up
    // (maybe some sanity checking), this would be the best place
    // for it.
}
#line 812 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 34:
#line 270 "dhcp4_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ctx.stack_.back(); ctx.stack_.pop_back(); }
#line 818 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 37:
#line 277 "dhcp4_parser.yy" // lalr1.cc:859
    {
                  // map containing a single entry
                  ctx.stack_.back()->set(yystack_[2].value.as< std::string > (), yystack_[0].value.as< ElementPtr > ());
                  }
#line 827 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 38:
#line 281 "dhcp4_parser.yy" // lalr1.cc:859
    {
                  // map consisting of a shorter map followed by
                  // comma and string:value
                  ctx.stack_.back()->set(yystack_[2].value.as< std::string > (), yystack_[0].value.as< ElementPtr > ());
                  }
#line 837 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 39:
#line 288 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr l(new ListElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.push_back(l);
}
#line 846 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 40:
#line 291 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // list parsing complete. Put any sanity checking here
}
#line 854 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 43:
#line 299 "dhcp4_parser.yy" // lalr1.cc:859
    {
                  // List consisting of a single element.
                  ctx.stack_.back()->add(yystack_[0].value.as< ElementPtr > ());
                  }
#line 863 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 44:
#line 303 "dhcp4_parser.yy" // lalr1.cc:859
    {
                  // List ending with , and a value.
                  ctx.stack_.back()->add(yystack_[0].value.as< ElementPtr > ());
                  }
#line 872 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 45:
#line 310 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // List parsing about to start
}
#line 880 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 46:
#line 312 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // list parsing complete. Put any sanity checking here
    //ctx.stack_.pop_back();
}
#line 889 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 49:
#line 321 "dhcp4_parser.yy" // lalr1.cc:859
    {
                          ElementPtr s(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
                          ctx.stack_.back()->add(s);
                          }
#line 898 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 50:
#line 325 "dhcp4_parser.yy" // lalr1.cc:859
    {
                          ElementPtr s(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
                          ctx.stack_.back()->add(s);
                          }
#line 907 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 51:
#line 336 "dhcp4_parser.yy" // lalr1.cc:859
    {
    const std::string& where = ctx.contextName();
    const std::string& keyword = yystack_[1].value.as< std::string > ();
    error(yystack_[1].location,
          "got unexpected keyword \"" + keyword + "\" in " + where + " map.");
}
#line 918 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 52:
#line 346 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // This code is executed when we're about to start parsing
    // the content of the map
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.push_back(m);
}
#line 929 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 53:
#line 351 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // map parsing completed. If we ever want to do any wrap up
    // (maybe some sanity checking), this would be the best place
    // for it.
}
#line 939 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 62:
#line 372 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // This code is executed when we're about to start parsing
    // the content of the map
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("Dhcp4", m);
    ctx.stack_.push_back(m);
    ctx.enter(ctx.DHCP4);
}
#line 952 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 63:
#line 379 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // map parsing completed. If we ever want to do any wrap up
    // (maybe some sanity checking), this would be the best place
    // for it.
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 964 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 64:
#line 389 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // Parse the Dhcp4 map
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.push_back(m);
}
#line 974 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 65:
#line 393 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // parsing completed
}
#line 982 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 89:
#line 426 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr prf(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("valid-lifetime", prf);
}
#line 991 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 90:
#line 431 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr prf(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("renew-timer", prf);
}
#line 1000 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 91:
#line 436 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr prf(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("rebind-timer", prf);
}
#line 1009 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 92:
#line 441 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr dpp(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("decline-probation-period", dpp);
}
#line 1018 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 93:
#line 446 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr echo(new BoolElement(yystack_[0].value.as< bool > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("echo-client-id", echo);
}
#line 1027 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 94:
#line 451 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr match(new BoolElement(yystack_[0].value.as< bool > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("match-client-id", match);
}
#line 1036 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 95:
#line 457 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr i(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("interfaces-config", i);
    ctx.stack_.push_back(i);
    ctx.enter(ctx.INTERFACES_CONFIG);
}
#line 1047 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 96:
#line 462 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 1056 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 102:
#line 476 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // Parse the interfaces-config map
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.push_back(m);
}
#line 1066 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 103:
#line 480 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // parsing completed
}
#line 1074 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 104:
#line 484 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr l(new ListElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("interfaces", l);
    ctx.stack_.push_back(l);
    ctx.enter(ctx.NO_KEYWORD);
}
#line 1085 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 105:
#line 489 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 1094 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 106:
#line 494 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.DHCP_SOCKET_TYPE);
}
#line 1102 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 107:
#line 496 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.back()->set("dhcp-socket-type", yystack_[0].value.as< ElementPtr > ());
    ctx.leave();
}
#line 1111 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 108:
#line 501 "dhcp4_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ElementPtr(new StringElement("raw", ctx.loc2pos(yystack_[0].location))); }
#line 1117 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 109:
#line 502 "dhcp4_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ElementPtr(new StringElement("udp", ctx.loc2pos(yystack_[0].location))); }
#line 1123 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 110:
#line 505 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr b(new BoolElement(yystack_[0].value.as< bool > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("re-detect", b);
}
#line 1132 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 111:
#line 511 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr i(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("lease-database", i);
    ctx.stack_.push_back(i);
    ctx.enter(ctx.LEASE_DATABASE);
}
#line 1143 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 112:
#line 516 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 1152 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 113:
#line 521 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr i(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("hosts-database", i);
    ctx.stack_.push_back(i);
    ctx.enter(ctx.HOSTS_DATABASE);
}
#line 1163 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 114:
#line 526 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 1172 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 130:
#line 550 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.DATABASE_TYPE);
}
#line 1180 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 131:
#line 552 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.back()->set("type", yystack_[0].value.as< ElementPtr > ());
    ctx.leave();
}
#line 1189 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 132:
#line 557 "dhcp4_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ElementPtr(new StringElement("memfile", ctx.loc2pos(yystack_[0].location))); }
#line 1195 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 133:
#line 558 "dhcp4_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ElementPtr(new StringElement("mysql", ctx.loc2pos(yystack_[0].location))); }
#line 1201 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 134:
#line 559 "dhcp4_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ElementPtr(new StringElement("postgresql", ctx.loc2pos(yystack_[0].location))); }
#line 1207 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 135:
#line 560 "dhcp4_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ElementPtr(new StringElement("cql", ctx.loc2pos(yystack_[0].location))); }
#line 1213 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 136:
#line 561 "dhcp4_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ElementPtr(new StringElement("radius", ctx.loc2pos(yystack_[0].location))); }
#line 1219 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 137:
#line 564 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 1227 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 138:
#line 566 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr user(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("user", user);
    ctx.leave();
}
#line 1237 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 139:
#line 572 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 1245 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 140:
#line 574 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr pwd(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("password", pwd);
    ctx.leave();
}
#line 1255 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 141:
#line 580 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 1263 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 142:
#line 582 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr h(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("host", h);
    ctx.leave();
}
#line 1273 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 143:
#line 588 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr p(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("port", p);
}
#line 1282 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 144:
#line 593 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 1290 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 145:
#line 595 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr name(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("name", name);
    ctx.leave();
}
#line 1300 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 146:
#line 601 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr n(new BoolElement(yystack_[0].value.as< bool > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("persist", n);
}
#line 1309 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 147:
#line 606 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr n(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("lfc-interval", n);
}
#line 1318 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 148:
#line 611 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr n(new BoolElement(yystack_[0].value.as< bool > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("readonly", n);
}
#line 1327 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 149:
#line 616 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr n(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("connect-timeout", n);
}
#line 1336 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 150:
#line 621 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 1344 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 151:
#line 623 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr cp(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("contact-points", cp);
    ctx.leave();
}
#line 1354 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 152:
#line 629 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 1362 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 153:
#line 631 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr ks(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("keyspace", ks);
    ctx.leave();
}
#line 1372 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 154:
#line 638 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr l(new ListElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("host-reservation-identifiers", l);
    ctx.stack_.push_back(l);
    ctx.enter(ctx.HOST_RESERVATION_IDENTIFIERS);
}
#line 1383 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 155:
#line 643 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 1392 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 163:
#line 659 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr duid(new StringElement("duid", ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->add(duid);
}
#line 1401 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 164:
#line 664 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr hwaddr(new StringElement("hw-address", ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->add(hwaddr);
}
#line 1410 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 165:
#line 669 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr circuit(new StringElement("circuit-id", ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->add(circuit);
}
#line 1419 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 166:
#line 674 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr client(new StringElement("client-id", ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->add(client);
}
#line 1428 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 167:
#line 679 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr flex_id(new StringElement("flex-id", ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->add(flex_id);
}
#line 1437 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 168:
#line 684 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr l(new ListElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("hooks-libraries", l);
    ctx.stack_.push_back(l);
    ctx.enter(ctx.HOOKS_LIBRARIES);
}
#line 1448 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 169:
#line 689 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 1457 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 174:
#line 702 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->add(m);
    ctx.stack_.push_back(m);
}
#line 1467 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 175:
#line 706 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
}
#line 1475 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 176:
#line 710 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // Parse the hooks-libraries list entry map
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.push_back(m);
}
#line 1485 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 177:
#line 714 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // parsing completed
}
#line 1493 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 183:
#line 727 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 1501 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 184:
#line 729 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr lib(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("library", lib);
    ctx.leave();
}
#line 1511 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 185:
#line 735 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 1519 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 186:
#line 737 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.back()->set("parameters", yystack_[0].value.as< ElementPtr > ());
    ctx.leave();
}
#line 1528 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 187:
#line 743 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("expired-leases-processing", m);
    ctx.stack_.push_back(m);
    ctx.enter(ctx.EXPIRED_LEASES_PROCESSING);
}
#line 1539 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 188:
#line 748 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 1548 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 197:
#line 765 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr value(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("reclaim-timer-wait-time", value);
}
#line 1557 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 198:
#line 770 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr value(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("flush-reclaimed-timer-wait-time", value);
}
#line 1566 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 199:
#line 775 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr value(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("hold-reclaimed-time", value);
}
#line 1575 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 200:
#line 780 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr value(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("max-reclaim-leases", value);
}
#line 1584 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 201:
#line 785 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr value(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("max-reclaim-time", value);
}
#line 1593 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 202:
#line 790 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr value(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("unwarned-reclaim-cycles", value);
}
#line 1602 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 203:
#line 798 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr l(new ListElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("subnet4", l);
    ctx.stack_.push_back(l);
    ctx.enter(ctx.SUBNET4);
}
#line 1613 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 204:
#line 803 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 1622 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 209:
#line 823 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->add(m);
    ctx.stack_.push_back(m);
}
#line 1632 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 210:
#line 827 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // Once we reached this place, the subnet parsing is now complete.
    // If we want to, we can implement default values here.
    // In particular we can do things like this:
    // if (!ctx.stack_.back()->get("interface")) {
    //     ctx.stack_.back()->set("interface", StringElement("loopback"));
    // }
    //
    // We can also stack up one level (Dhcp4) and copy over whatever
    // global parameters we want to:
    // if (!ctx.stack_.back()->get("renew-timer")) {
    //     ElementPtr renew = ctx_stack_[...].get("renew-timer");
    //     if (renew) {
    //         ctx.stack_.back()->set("renew-timer", renew);
    //     }
    // }
    ctx.stack_.pop_back();
}
#line 1655 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 211:
#line 846 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // Parse the subnet4 list entry map
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.push_back(m);
}
#line 1665 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 212:
#line 850 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // parsing completed
}
#line 1673 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 235:
#line 882 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 1681 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 236:
#line 884 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr subnet(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("subnet", subnet);
    ctx.leave();
}
#line 1691 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 237:
#line 890 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 1699 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 238:
#line 892 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr iface(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("4o6-interface", iface);
    ctx.leave();
}
#line 1709 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 239:
#line 898 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 1717 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 240:
#line 900 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr iface(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("4o6-interface-id", iface);
    ctx.leave();
}
#line 1727 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 241:
#line 906 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 1735 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 242:
#line 908 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr iface(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("4o6-subnet", iface);
    ctx.leave();
}
#line 1745 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 243:
#line 914 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 1753 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 244:
#line 916 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr iface(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("interface", iface);
    ctx.leave();
}
#line 1763 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 245:
#line 922 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 1771 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 246:
#line 924 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr iface(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("interface-id", iface);
    ctx.leave();
}
#line 1781 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 247:
#line 930 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.CLIENT_CLASS);
}
#line 1789 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 248:
#line 932 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr cls(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("client-class", cls);
    ctx.leave();
}
#line 1799 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 249:
#line 938 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.RESERVATION_MODE);
}
#line 1807 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 250:
#line 940 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.back()->set("reservation-mode", yystack_[0].value.as< ElementPtr > ());
    ctx.leave();
}
#line 1816 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 251:
#line 945 "dhcp4_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ElementPtr(new StringElement("disabled", ctx.loc2pos(yystack_[0].location))); }
#line 1822 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 252:
#line 946 "dhcp4_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ElementPtr(new StringElement("out-of-pool", ctx.loc2pos(yystack_[0].location))); }
#line 1828 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 253:
#line 947 "dhcp4_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ElementPtr(new StringElement("all", ctx.loc2pos(yystack_[0].location))); }
#line 1834 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 254:
#line 950 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr id(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("id", id);
}
#line 1843 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 255:
#line 955 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr rc(new BoolElement(yystack_[0].value.as< bool > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("rapid-commit", rc);
}
#line 1852 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 256:
#line 964 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr l(new ListElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("option-def", l);
    ctx.stack_.push_back(l);
    ctx.enter(ctx.OPTION_DEF);
}
#line 1863 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 257:
#line 969 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 1872 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 262:
#line 986 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->add(m);
    ctx.stack_.push_back(m);
}
#line 1882 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 263:
#line 990 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
}
#line 1890 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 264:
#line 997 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // Parse the option-def list entry map
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.push_back(m);
}
#line 1900 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 265:
#line 1001 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // parsing completed
}
#line 1908 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 279:
#line 1027 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr code(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("code", code);
}
#line 1917 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 281:
#line 1034 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 1925 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 282:
#line 1036 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr prf(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("type", prf);
    ctx.leave();
}
#line 1935 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 283:
#line 1042 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 1943 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 284:
#line 1044 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr rtypes(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("record-types", rtypes);
    ctx.leave();
}
#line 1953 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 285:
#line 1050 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 1961 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 286:
#line 1052 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr space(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("space", space);
    ctx.leave();
}
#line 1971 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 288:
#line 1060 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 1979 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 289:
#line 1062 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr encap(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("encapsulate", encap);
    ctx.leave();
}
#line 1989 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 290:
#line 1068 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr array(new BoolElement(yystack_[0].value.as< bool > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("array", array);
}
#line 1998 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 291:
#line 1077 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr l(new ListElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("option-data", l);
    ctx.stack_.push_back(l);
    ctx.enter(ctx.OPTION_DATA);
}
#line 2009 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 292:
#line 1082 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 2018 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 297:
#line 1101 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->add(m);
    ctx.stack_.push_back(m);
}
#line 2028 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 298:
#line 1105 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
}
#line 2036 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 299:
#line 1112 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // Parse the option-data list entry map
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.push_back(m);
}
#line 2046 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 300:
#line 1116 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // parsing completed
}
#line 2054 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 313:
#line 1146 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2062 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 314:
#line 1148 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr data(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("data", data);
    ctx.leave();
}
#line 2072 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 317:
#line 1158 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr space(new BoolElement(yystack_[0].value.as< bool > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("csv-format", space);
}
#line 2081 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 318:
#line 1163 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr persist(new BoolElement(yystack_[0].value.as< bool > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("always-send", persist);
}
#line 2090 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 319:
#line 1171 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr l(new ListElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("pools", l);
    ctx.stack_.push_back(l);
    ctx.enter(ctx.POOLS);
}
#line 2101 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 320:
#line 1176 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 2110 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 325:
#line 1191 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->add(m);
    ctx.stack_.push_back(m);
}
#line 2120 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 326:
#line 1195 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
}
#line 2128 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 327:
#line 1199 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // Parse the pool list entry map
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.push_back(m);
}
#line 2138 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 328:
#line 1203 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // parsing completed
}
#line 2146 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 335:
#line 1217 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2154 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 336:
#line 1219 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr pool(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("pool", pool);
    ctx.leave();
}
#line 2164 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 337:
#line 1225 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2172 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 338:
#line 1227 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.back()->set("user-context", yystack_[0].value.as< ElementPtr > ());
    ctx.leave();
}
#line 2181 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 339:
#line 1235 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr l(new ListElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("reservations", l);
    ctx.stack_.push_back(l);
    ctx.enter(ctx.RESERVATIONS);
}
#line 2192 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 340:
#line 1240 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 2201 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 345:
#line 1253 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->add(m);
    ctx.stack_.push_back(m);
}
#line 2211 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 346:
#line 1257 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
}
#line 2219 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 347:
#line 1261 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // Parse the reservations list entry map
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.push_back(m);
}
#line 2229 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 348:
#line 1265 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // parsing completed
}
#line 2237 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 366:
#line 1293 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2245 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 367:
#line 1295 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr next_server(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("next-server", next_server);
    ctx.leave();
}
#line 2255 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 368:
#line 1301 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2263 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 369:
#line 1303 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr srv(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("server-hostname", srv);
    ctx.leave();
}
#line 2273 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 370:
#line 1309 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2281 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 371:
#line 1311 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr bootfile(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("boot-file-name", bootfile);
    ctx.leave();
}
#line 2291 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 372:
#line 1317 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2299 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 373:
#line 1319 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr addr(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("ip-address", addr);
    ctx.leave();
}
#line 2309 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 374:
#line 1325 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2317 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 375:
#line 1327 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr d(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("duid", d);
    ctx.leave();
}
#line 2327 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 376:
#line 1333 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2335 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 377:
#line 1335 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr hw(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("hw-address", hw);
    ctx.leave();
}
#line 2345 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 378:
#line 1341 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2353 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 379:
#line 1343 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr hw(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("client-id", hw);
    ctx.leave();
}
#line 2363 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 380:
#line 1349 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2371 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 381:
#line 1351 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr hw(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("circuit-id", hw);
    ctx.leave();
}
#line 2381 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 382:
#line 1357 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2389 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 383:
#line 1359 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr hw(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("flex-id", hw);
    ctx.leave();
}
#line 2399 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 384:
#line 1365 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2407 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 385:
#line 1367 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr host(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("hostname", host);
    ctx.leave();
}
#line 2417 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 386:
#line 1373 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr c(new ListElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("client-classes", c);
    ctx.stack_.push_back(c);
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2428 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 387:
#line 1378 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 2437 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 388:
#line 1386 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("relay", m);
    ctx.stack_.push_back(m);
    ctx.enter(ctx.RELAY);
}
#line 2448 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 389:
#line 1391 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 2457 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 390:
#line 1396 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2465 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 391:
#line 1398 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr ip(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("ip-address", ip);
    ctx.leave();
}
#line 2475 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 392:
#line 1407 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr l(new ListElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("client-classes", l);
    ctx.stack_.push_back(l);
    ctx.enter(ctx.CLIENT_CLASSES);
}
#line 2486 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 393:
#line 1412 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 2495 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 396:
#line 1421 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->add(m);
    ctx.stack_.push_back(m);
}
#line 2505 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 397:
#line 1425 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
}
#line 2513 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 410:
#line 1448 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2521 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 411:
#line 1450 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr test(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("test", test);
    ctx.leave();
}
#line 2531 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 412:
#line 1460 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr time(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("dhcp4o6-port", time);
}
#line 2540 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 413:
#line 1467 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("control-socket", m);
    ctx.stack_.push_back(m);
    ctx.enter(ctx.CONTROL_SOCKET);
}
#line 2551 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 414:
#line 1472 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 2560 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 419:
#line 1485 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2568 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 420:
#line 1487 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr stype(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("socket-type", stype);
    ctx.leave();
}
#line 2578 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 421:
#line 1493 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2586 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 422:
#line 1495 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr name(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("socket-name", name);
    ctx.leave();
}
#line 2596 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 423:
#line 1503 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("dhcp-ddns", m);
    ctx.stack_.push_back(m);
    ctx.enter(ctx.DHCP_DDNS);
}
#line 2607 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 424:
#line 1508 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 2616 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 425:
#line 1513 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // Parse the dhcp-ddns map
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.push_back(m);
}
#line 2626 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 426:
#line 1517 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // parsing completed
}
#line 2634 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 444:
#line 1542 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr b(new BoolElement(yystack_[0].value.as< bool > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("enable-updates", b);
}
#line 2643 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 445:
#line 1547 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2651 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 446:
#line 1549 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr s(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("qualifying-suffix", s);
    ctx.leave();
}
#line 2661 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 447:
#line 1555 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2669 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 448:
#line 1557 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr s(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("server-ip", s);
    ctx.leave();
}
#line 2679 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 449:
#line 1563 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr i(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("server-port", i);
}
#line 2688 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 450:
#line 1568 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2696 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 451:
#line 1570 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr s(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("sender-ip", s);
    ctx.leave();
}
#line 2706 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 452:
#line 1576 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr i(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("sender-port", i);
}
#line 2715 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 453:
#line 1581 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr i(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("max-queue-size", i);
}
#line 2724 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 454:
#line 1586 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NCR_PROTOCOL);
}
#line 2732 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 455:
#line 1588 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.back()->set("ncr-protocol", yystack_[0].value.as< ElementPtr > ());
    ctx.leave();
}
#line 2741 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 456:
#line 1594 "dhcp4_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ElementPtr(new StringElement("UDP", ctx.loc2pos(yystack_[0].location))); }
#line 2747 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 457:
#line 1595 "dhcp4_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ElementPtr(new StringElement("TCP", ctx.loc2pos(yystack_[0].location))); }
#line 2753 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 458:
#line 1598 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NCR_FORMAT);
}
#line 2761 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 459:
#line 1600 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr json(new StringElement("JSON", ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("ncr-format", json);
    ctx.leave();
}
#line 2771 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 460:
#line 1606 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr b(new BoolElement(yystack_[0].value.as< bool > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("always-include-fqdn", b);
}
#line 2780 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 461:
#line 1611 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr b(new BoolElement(yystack_[0].value.as< bool > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("override-no-update", b);
}
#line 2789 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 462:
#line 1616 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr b(new BoolElement(yystack_[0].value.as< bool > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("override-client-update", b);
}
#line 2798 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 463:
#line 1621 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.REPLACE_CLIENT_NAME);
}
#line 2806 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 464:
#line 1623 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.back()->set("replace-client-name", yystack_[0].value.as< ElementPtr > ());
    ctx.leave();
}
#line 2815 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 465:
#line 1629 "dhcp4_parser.yy" // lalr1.cc:859
    {
      yylhs.value.as< ElementPtr > () = ElementPtr(new StringElement("when-present", ctx.loc2pos(yystack_[0].location))); 
      }
#line 2823 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 466:
#line 1632 "dhcp4_parser.yy" // lalr1.cc:859
    {
      yylhs.value.as< ElementPtr > () = ElementPtr(new StringElement("never", ctx.loc2pos(yystack_[0].location)));
      }
#line 2831 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 467:
#line 1635 "dhcp4_parser.yy" // lalr1.cc:859
    {
      yylhs.value.as< ElementPtr > () = ElementPtr(new StringElement("always", ctx.loc2pos(yystack_[0].location)));
      }
#line 2839 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 468:
#line 1638 "dhcp4_parser.yy" // lalr1.cc:859
    {
      yylhs.value.as< ElementPtr > () = ElementPtr(new StringElement("when-not-present", ctx.loc2pos(yystack_[0].location)));
      }
#line 2847 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 469:
#line 1641 "dhcp4_parser.yy" // lalr1.cc:859
    {
      error(yystack_[0].location, "boolean values for the replace-client-name are "
                "no longer supported");
      }
#line 2856 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 470:
#line 1647 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2864 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 471:
#line 1649 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr s(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("generated-prefix", s);
    ctx.leave();
}
#line 2874 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 472:
#line 1657 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2882 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 473:
#line 1659 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.back()->set("Dhcp6", yystack_[0].value.as< ElementPtr > ());
    ctx.leave();
}
#line 2891 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 474:
#line 1664 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2899 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 475:
#line 1666 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.back()->set("DhcpDdns", yystack_[0].value.as< ElementPtr > ());
    ctx.leave();
}
#line 2908 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 476:
#line 1671 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2916 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 477:
#line 1673 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.back()->set("Control-agent", yystack_[0].value.as< ElementPtr > ());
    ctx.leave();
}
#line 2925 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 478:
#line 1683 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("Logging", m);
    ctx.stack_.push_back(m);
    ctx.enter(ctx.LOGGING);
}
#line 2936 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 479:
#line 1688 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 2945 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 483:
#line 1705 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr l(new ListElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("loggers", l);
    ctx.stack_.push_back(l);
    ctx.enter(ctx.LOGGERS);
}
#line 2956 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 484:
#line 1710 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 2965 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 487:
#line 1722 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr l(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->add(l);
    ctx.stack_.push_back(l);
}
#line 2975 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 488:
#line 1726 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
}
#line 2983 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 496:
#line 1741 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr dl(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("debuglevel", dl);
}
#line 2992 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 497:
#line 1746 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 3000 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 498:
#line 1748 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr sev(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("severity", sev);
    ctx.leave();
}
#line 3010 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 499:
#line 1754 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr l(new ListElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("output_options", l);
    ctx.stack_.push_back(l);
    ctx.enter(ctx.OUTPUT_OPTIONS);
}
#line 3021 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 500:
#line 1759 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 3030 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 503:
#line 1768 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->add(m);
    ctx.stack_.push_back(m);
}
#line 3040 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 504:
#line 1772 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
}
#line 3048 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 511:
#line 1786 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 3056 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 512:
#line 1788 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr sev(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("output", sev);
    ctx.leave();
}
#line 3066 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 513:
#line 1794 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr flush(new BoolElement(yystack_[0].value.as< bool > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("flush", flush);
}
#line 3075 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 514:
#line 1799 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr maxsize(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("maxsize", maxsize);
}
#line 3084 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 515:
#line 1804 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr maxver(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("maxver", maxver);
}
#line 3093 "dhcp4_parser.cc" // lalr1.cc:859
    break;


#line 3097 "dhcp4_parser.cc" // lalr1.cc:859
            default:
              break;
            }
        }
      catch (const syntax_error& yyexc)
        {
          error (yyexc);
          YYERROR;
        }
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;
      YY_STACK_PRINT ();

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, yylhs);
    }
    goto yynewstate;

  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        error (yyla.location, yysyntax_error_ (yystack_[0].state, yyla));
      }


    yyerror_range[1].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.type_get () == yyeof_)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:

    /* Pacify compilers like GCC when the user code never invokes
       YYERROR and the label yyerrorlab therefore never appears in user
       code.  */
    if (false)
      goto yyerrorlab;
    yyerror_range[1].location = yystack_[yylen - 1].location;
    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    goto yyerrlab1;

  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    {
      stack_symbol_type error_token;
      for (;;)
        {
          yyn = yypact_[yystack_[0].state];
          if (!yy_pact_value_is_default_ (yyn))
            {
              yyn += yyterror_;
              if (0 <= yyn && yyn <= yylast_ && yycheck_[yyn] == yyterror_)
                {
                  yyn = yytable_[yyn];
                  if (0 < yyn)
                    break;
                }
            }

          // Pop the current state because it cannot handle the error token.
          if (yystack_.size () == 1)
            YYABORT;

          yyerror_range[1].location = yystack_[0].location;
          yy_destroy_ ("Error: popping", yystack_[0]);
          yypop_ ();
          YY_STACK_PRINT ();
        }

      yyerror_range[2].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, yyerror_range, 2);

      // Shift the error token.
      error_token.state = yyn;
      yypush_ ("Shifting", error_token);
    }
    goto yynewstate;

    // Accept.
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;

    // Abort.
  yyabortlab:
    yyresult = 1;
    goto yyreturn;

  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack"
                 << std::endl;
        // Do not try to display the values of the reclaimed symbols,
        // as their printer might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
  }

  void
  Dhcp4Parser::error (const syntax_error& yyexc)
  {
    error (yyexc.location, yyexc.what());
  }

  // Generate an error message.
  std::string
  Dhcp4Parser::yysyntax_error_ (state_type yystate, const symbol_type& yyla) const
  {
    // Number of reported tokens (one for the "unexpected", one per
    // "expected").
    size_t yycount = 0;
    // Its maximum.
    enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
    // Arguments of yyformat.
    char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];

    /* There are many possibilities here to consider:
       - If this state is a consistent state with a default action, then
         the only way this function was invoked is if the default action
         is an error action.  In that case, don't check for expected
         tokens because there are none.
       - The only way there can be no lookahead present (in yyla) is
         if this state is a consistent state with a default action.
         Thus, detecting the absence of a lookahead is sufficient to
         determine that there is no unexpected or expected token to
         report.  In that case, just report a simple "syntax error".
       - Don't assume there isn't a lookahead just because this state is
         a consistent state with a default action.  There might have
         been a previous inconsistent state, consistent state with a
         non-default action, or user semantic action that manipulated
         yyla.  (However, yyla is currently not documented for users.)
       - Of course, the expected token list depends on states to have
         correct lookahead information, and it depends on the parser not
         to perform extra reductions after fetching a lookahead from the
         scanner and before detecting a syntax error.  Thus, state
         merging (from LALR or IELR) and default reductions corrupt the
         expected token list.  However, the list is correct for
         canonical LR with one exception: it will still contain any
         token that will not be accepted due to an error action in a
         later state.
    */
    if (!yyla.empty ())
      {
        int yytoken = yyla.type_get ();
        yyarg[yycount++] = yytname_[yytoken];
        int yyn = yypact_[yystate];
        if (!yy_pact_value_is_default_ (yyn))
          {
            /* Start YYX at -YYN if negative to avoid negative indexes in
               YYCHECK.  In other words, skip the first -YYN actions for
               this state because they are default actions.  */
            int yyxbegin = yyn < 0 ? -yyn : 0;
            // Stay within bounds of both yycheck and yytname.
            int yychecklim = yylast_ - yyn + 1;
            int yyxend = yychecklim < yyntokens_ ? yychecklim : yyntokens_;
            for (int yyx = yyxbegin; yyx < yyxend; ++yyx)
              if (yycheck_[yyx + yyn] == yyx && yyx != yyterror_
                  && !yy_table_value_is_error_ (yytable_[yyx + yyn]))
                {
                  if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                    {
                      yycount = 1;
                      break;
                    }
                  else
                    yyarg[yycount++] = yytname_[yyx];
                }
          }
      }

    char const* yyformat = YY_NULLPTR;
    switch (yycount)
      {
#define YYCASE_(N, S)                         \
        case N:                               \
          yyformat = S;                       \
        break
        YYCASE_(0, YY_("syntax error"));
        YYCASE_(1, YY_("syntax error, unexpected %s"));
        YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
        YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
        YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
        YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
      }

    std::string yyres;
    // Argument number.
    size_t yyi = 0;
    for (char const* yyp = yyformat; *yyp; ++yyp)
      if (yyp[0] == '%' && yyp[1] == 's' && yyi < yycount)
        {
          yyres += yytnamerr_ (yyarg[yyi++]);
          ++yyp;
        }
      else
        yyres += *yyp;
    return yyres;
  }


  const short int Dhcp4Parser::yypact_ninf_ = -486;

  const signed char Dhcp4Parser::yytable_ninf_ = -1;

  const short int
  Dhcp4Parser::yypact_[] =
  {
      93,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,
    -486,  -486,    33,    19,    35,    39,    80,    82,    97,   106,
     108,   134,   135,   148,  -486,  -486,  -486,  -486,  -486,  -486,
    -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,
    -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,
    -486,  -486,  -486,  -486,  -486,  -486,    19,   -74,    17,    30,
      22,    18,   -10,    99,    81,    57,   -56,   150,  -486,   160,
     167,   169,   176,   182,  -486,  -486,  -486,  -486,  -486,   183,
    -486,    53,  -486,  -486,  -486,  -486,  -486,  -486,  -486,   184,
     206,  -486,  -486,  -486,   210,   216,   217,   238,  -486,  -486,
    -486,  -486,  -486,  -486,  -486,   241,  -486,  -486,  -486,    54,
    -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,
    -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,
    -486,  -486,  -486,   242,    87,  -486,  -486,  -486,  -486,  -486,
    -486,  -486,  -486,  -486,  -486,  -486,  -486,   270,   271,  -486,
    -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,   113,  -486,
    -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,
    -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,   127,
    -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,
    -486,  -486,  -486,  -486,  -486,   200,   215,  -486,  -486,  -486,
    -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,
    -486,   285,  -486,  -486,  -486,   289,  -486,  -486,   228,   262,
    -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,
    -486,   290,   292,  -486,  -486,  -486,  -486,   274,   297,  -486,
    -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,   141,
    -486,  -486,  -486,   298,  -486,  -486,   299,  -486,   301,   303,
    -486,  -486,   305,   308,   309,  -486,  -486,  -486,   166,  -486,
    -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,
    -486,  -486,  -486,  -486,  -486,    19,    19,  -486,   168,   310,
     312,   314,   315,   316,  -486,    17,  -486,   322,   191,   192,
     324,   325,   334,   196,   197,   198,   199,   339,   340,   341,
     342,   343,   344,   345,   207,   347,   348,    30,  -486,   349,
     350,   211,    22,  -486,    77,   351,   356,   357,   358,   359,
     360,   361,   223,   222,   364,   365,   366,   367,    18,  -486,
     368,   369,   -10,  -486,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,  -486,    99,   380,   381,   243,   383,
     384,   385,   245,  -486,    81,   387,   247,   248,  -486,    57,
     390,   391,   -31,  -486,   251,   393,   394,   256,   396,   258,
     259,   399,   400,   263,   265,   266,   401,   402,   150,  -486,
    -486,  -486,   403,   405,   406,    19,    19,    19,  -486,   407,
    -486,  -486,   267,   408,   409,  -486,  -486,  -486,  -486,   412,
     413,   414,   415,   416,   417,   418,  -486,   419,   420,  -486,
     423,    61,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,
    -486,   421,   427,  -486,  -486,  -486,   281,   291,   293,   426,
     294,   295,   296,  -486,  -486,    88,   300,   429,   425,  -486,
     304,   433,  -486,   311,   313,   423,   317,   318,   319,   321,
     323,   326,   328,  -486,   329,   330,  -486,   332,   333,   335,
    -486,  -486,   336,  -486,  -486,  -486,   337,    19,  -486,  -486,
     338,   346,  -486,   352,  -486,  -486,    16,   327,  -486,  -486,
    -486,    36,   353,  -486,    19,    30,   331,  -486,  -486,  -486,
      22,  -486,   159,   159,   436,   440,   443,   246,    25,   445,
     112,    26,   150,  -486,  -486,  -486,  -486,  -486,   453,  -486,
      77,  -486,  -486,  -486,   451,  -486,  -486,  -486,  -486,  -486,
    -486,  -486,  -486,   457,   398,  -486,  -486,  -486,  -486,  -486,
    -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,
    -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,
    -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,
    -486,   203,  -486,   204,  -486,  -486,   214,  -486,  -486,  -486,
    -486,   463,   472,   478,   479,   480,  -486,  -486,  -486,   232,
    -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,
    -486,  -486,  -486,   235,  -486,   481,   482,  -486,  -486,   483,
     487,  -486,  -486,   485,   489,  -486,  -486,  -486,  -486,  -486,
    -486,    63,  -486,  -486,  -486,  -486,  -486,  -486,  -486,    85,
    -486,   490,   494,  -486,   495,   496,   497,   498,   499,   500,
     236,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,
     260,  -486,  -486,  -486,   261,   363,   382,  -486,  -486,   492,
     503,  -486,  -486,   501,   505,  -486,  -486,   502,  -486,   507,
     331,  -486,  -486,   508,   509,   510,   511,   386,   279,   388,
     389,   392,   512,   513,   159,  -486,  -486,    18,  -486,   436,
      81,  -486,   440,    57,  -486,   443,   246,  -486,    25,  -486,
     -56,  -486,   445,   395,   397,   404,   410,   411,   422,   112,
    -486,   514,   515,    26,  -486,  -486,  -486,   516,   506,  -486,
     -10,  -486,   451,    99,  -486,   457,   517,  -486,   488,  -486,
     306,   424,   428,   430,  -486,  -486,  -486,  -486,  -486,   431,
     432,  -486,   264,  -486,   518,  -486,   519,  -486,  -486,  -486,
     268,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,   434,
     435,  -486,  -486,   437,   278,  -486,   520,  -486,   438,   523,
    -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,
    -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,
    -486,  -486,   100,  -486,    44,   523,  -486,  -486,   521,  -486,
    -486,  -486,   280,  -486,  -486,  -486,  -486,  -486,   528,   439,
     529,    44,  -486,   531,  -486,   441,  -486,   530,  -486,  -486,
     137,  -486,   -82,   530,  -486,  -486,   535,   537,   538,   282,
    -486,  -486,  -486,  -486,  -486,  -486,   539,   442,   446,   447,
     -82,  -486,   444,  -486,  -486,  -486,  -486,  -486
  };

  const unsigned short int
  Dhcp4Parser::yydefact_[] =
  {
       0,     2,     4,     6,     8,    10,    12,    14,    16,    18,
      20,    22,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     1,    39,    32,    28,    27,    24,
      25,    26,    31,     3,    29,    30,    52,     5,    64,     7,
     102,     9,   211,    11,   327,    13,   347,    15,   264,    17,
     299,    19,   176,    21,   425,    23,    41,    35,     0,     0,
       0,     0,     0,   349,   266,   301,     0,     0,    43,     0,
      42,     0,     0,    36,    62,   478,   472,   474,   476,     0,
      61,     0,    54,    56,    58,    59,    60,    57,    95,     0,
       0,   366,   111,   113,     0,     0,     0,     0,   203,   256,
     291,   154,   392,   168,   187,     0,   413,   423,    88,     0,
      66,    68,    69,    70,    71,    85,    86,    73,    74,    75,
      76,    80,    81,    72,    78,    79,    87,    77,    82,    83,
      84,   104,   106,     0,     0,    97,    99,   100,   101,   396,
     237,   239,   241,   319,   235,   243,   245,     0,     0,   249,
     247,   339,   388,   234,   215,   216,   217,   229,     0,   213,
     220,   231,   232,   233,   221,   222,   225,   227,   223,   224,
     218,   219,   226,   230,   228,   335,   337,   334,   332,     0,
     329,   331,   333,   368,   370,   386,   374,   376,   380,   378,
     384,   382,   372,   365,   361,     0,   350,   351,   362,   363,
     364,   358,   353,   359,   355,   356,   357,   360,   354,   281,
     144,     0,   285,   283,   288,     0,   277,   278,     0,   267,
     268,   270,   280,   271,   272,   273,   287,   274,   275,   276,
     313,     0,     0,   311,   312,   315,   316,     0,   302,   303,
     305,   306,   307,   308,   309,   310,   183,   185,   180,     0,
     178,   181,   182,     0,   445,   447,     0,   450,     0,     0,
     454,   458,     0,     0,     0,   463,   470,   443,     0,   427,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,    40,     0,     0,    33,     0,     0,
       0,     0,     0,     0,    51,     0,    53,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    65,     0,
       0,     0,     0,   103,   398,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   212,
       0,     0,     0,   328,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   348,     0,     0,     0,     0,     0,
       0,     0,     0,   265,     0,     0,     0,     0,   300,     0,
       0,     0,     0,   177,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   426,
      44,    37,     0,     0,     0,     0,     0,     0,    55,     0,
      93,    94,     0,     0,     0,    89,    90,    91,    92,     0,
       0,     0,     0,     0,     0,     0,   412,     0,     0,    67,
       0,     0,   110,    98,   410,   408,   409,   404,   405,   406,
     407,     0,   399,   400,   402,   403,     0,     0,     0,     0,
       0,     0,     0,   254,   255,     0,     0,     0,     0,   214,
       0,     0,   330,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   352,     0,     0,   279,     0,     0,     0,
     290,   269,     0,   317,   318,   304,     0,     0,   179,   444,
       0,     0,   449,     0,   452,   453,     0,     0,   460,   461,
     462,     0,     0,   428,     0,     0,     0,   473,   475,   477,
       0,   367,     0,     0,   205,   258,   293,     0,     0,   170,
       0,     0,     0,    45,   105,   108,   109,   107,     0,   397,
       0,   238,   240,   242,   321,   236,   244,   246,   251,   252,
     253,   250,   248,   341,     0,   336,    34,   338,   369,   371,
     387,   375,   377,   381,   379,   385,   383,   373,   282,   145,
     286,   284,   289,   314,   184,   186,   446,   448,   451,   456,
     457,   455,   459,   465,   466,   467,   468,   469,   464,   471,
      38,     0,   483,     0,   480,   482,     0,   130,   137,   139,
     141,     0,     0,     0,     0,     0,   150,   152,   129,     0,
     115,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,     0,   209,     0,   206,   207,   262,     0,
     259,   260,   297,     0,   294,   295,   163,   164,   165,   166,
     167,     0,   156,   158,   159,   160,   161,   162,   394,     0,
     174,     0,   171,   172,     0,     0,     0,     0,     0,     0,
       0,   189,   191,   192,   193,   194,   195,   196,   419,   421,
       0,   415,   417,   418,     0,    47,     0,   401,   325,     0,
     322,   323,   345,     0,   342,   343,   390,     0,    63,     0,
       0,   479,    96,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   112,   114,     0,   204,     0,
     266,   257,     0,   301,   292,     0,     0,   155,     0,   393,
       0,   169,     0,     0,     0,     0,     0,     0,     0,     0,
     188,     0,     0,     0,   414,   424,    49,     0,    48,   411,
       0,   320,     0,   349,   340,     0,     0,   389,     0,   481,
       0,     0,     0,     0,   143,   146,   147,   148,   149,     0,
       0,   116,     0,   208,     0,   261,     0,   296,   157,   395,
       0,   173,   197,   198,   199,   200,   201,   202,   190,     0,
       0,   416,    46,     0,     0,   324,     0,   344,     0,     0,
     132,   133,   134,   135,   136,   131,   138,   140,   142,   151,
     153,   210,   263,   298,   175,   420,   422,    50,   326,   346,
     391,   487,     0,   485,     0,     0,   484,   499,     0,   497,
     495,   491,     0,   489,   493,   494,   492,   486,     0,     0,
       0,     0,   488,     0,   496,     0,   490,     0,   498,   503,
       0,   501,     0,     0,   500,   511,     0,     0,     0,     0,
     505,   507,   508,   509,   510,   502,     0,     0,     0,     0,
       0,   504,     0,   513,   514,   515,   506,   512
  };

  const short int
  Dhcp4Parser::yypgoto_[] =
  {
    -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,
    -486,  -486,  -486,   -38,  -486,    69,  -486,  -486,  -486,  -486,
    -486,  -486,  -486,  -486,    31,  -486,  -486,  -486,   -58,  -486,
    -486,  -486,   249,  -486,  -486,  -486,  -486,    28,   229,   -60,
     -59,   -40,  -486,  -486,   -39,  -486,  -486,    45,   226,  -486,
    -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,
    -486,    46,  -134,  -486,  -486,  -486,  -486,  -486,  -486,  -486,
    -486,  -486,  -486,   -54,  -486,  -486,  -486,  -486,  -486,  -486,
    -486,  -486,  -486,  -486,  -486,  -486,  -145,  -486,  -486,  -486,
    -486,  -486,  -486,  -486,  -486,  -486,  -150,  -486,  -486,  -486,
    -144,   185,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -154,
    -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,
    -131,  -486,  -486,  -486,  -128,   224,  -486,  -486,  -486,  -486,
    -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -485,  -486,
    -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -132,
    -486,  -486,  -486,  -129,  -486,   205,  -486,   -52,  -486,  -486,
    -486,  -486,  -486,   -48,  -486,  -486,  -486,  -486,  -486,   -47,
    -486,  -486,  -486,  -127,  -486,  -486,  -486,  -130,  -486,   195,
    -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,
    -486,  -155,  -486,  -486,  -486,  -149,   233,  -486,  -486,  -486,
    -486,  -486,  -486,  -486,  -486,  -147,  -486,  -486,  -486,  -142,
    -486,   230,   -51,  -486,  -305,  -486,  -304,  -486,  -486,  -486,
    -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,
    -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,
    -486,  -486,  -486,  -486,    64,  -486,  -486,  -486,  -486,  -486,
    -486,  -486,  -125,  -486,  -486,  -486,  -486,  -486,  -486,  -486,
    -486,    79,   208,  -486,  -486,  -486,  -486,  -486,  -486,  -486,
    -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,
    -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,  -486,
    -486,  -486,  -486,  -486,  -486,   -78,  -486,  -486,  -486,  -202,
    -486,  -486,  -217,  -486,  -486,  -486,  -486,  -486,  -486,  -228,
    -486,  -486,  -243,  -486,  -486,  -486,  -486,  -486
  };

  const short int
  Dhcp4Parser::yydefgoto_[] =
  {
      -1,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    32,    33,    34,    57,   537,    72,    73,
      35,    56,    69,    70,   514,   655,   717,   718,   108,    37,
      58,    81,    82,    83,   289,    39,    59,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   297,   134,   135,    41,
      60,   136,   319,   137,   320,   517,   138,   118,   301,   119,
     302,   589,   590,   591,   673,   775,   592,   674,   593,   675,
     594,   676,   595,   217,   357,   597,   598,   599,   600,   601,
     682,   602,   683,   120,   310,   621,   622,   623,   624,   625,
     626,   627,   121,   312,   631,   632,   633,   700,    53,    66,
     249,   250,   251,   370,   252,   371,   122,   313,   640,   641,
     642,   643,   644,   645,   646,   647,   123,   307,   605,   606,
     607,   687,    43,    61,   158,   159,   160,   329,   161,   325,
     162,   326,   163,   327,   164,   330,   165,   331,   166,   335,
     167,   334,   531,   168,   169,   124,   308,   609,   610,   611,
     690,    49,    64,   218,   219,   220,   221,   222,   223,   224,
     356,   225,   360,   226,   359,   227,   228,   361,   229,   125,
     309,   613,   614,   615,   693,    51,    65,   237,   238,   239,
     240,   241,   365,   242,   243,   244,   245,   171,   328,   659,
     660,   661,   720,    45,    62,   179,   180,   181,   340,   182,
     341,   172,   336,   663,   664,   665,   723,    47,    63,   195,
     196,   197,   126,   300,   199,   344,   200,   345,   201,   353,
     202,   347,   203,   348,   204,   350,   205,   349,   206,   352,
     207,   351,   208,   346,   174,   337,   667,   726,   127,   311,
     629,   324,   431,   432,   433,   434,   435,   518,   128,   129,
     315,   650,   651,   652,   711,   653,   712,   130,   316,    55,
      67,   268,   269,   270,   271,   375,   272,   376,   273,   274,
     378,   275,   276,   277,   381,   561,   278,   382,   279,   280,
     281,   282,   386,   568,   283,   387,    84,   291,    85,   292,
      86,   293,    87,   290,   573,   574,   575,   669,   792,   793,
     794,   802,   803,   804,   805,   810,   806,   808,   820,   821,
     822,   829,   830,   831,   836,   832,   833,   834
  };

  const unsigned short int
  Dhcp4Parser::yytable_[] =
  {
      80,   154,   155,   153,   177,   193,   216,   233,   248,   267,
     173,   234,   198,   235,   170,   178,   194,   236,    68,   429,
     430,   156,   157,   628,    25,   139,    26,    74,    27,   246,
     247,   559,   139,    24,   131,   132,    90,    91,   133,   100,
     825,    88,    36,   826,   827,   828,    38,    89,    90,    91,
     175,   176,    92,    93,   246,   247,   295,   317,    94,    95,
      96,   296,   318,   140,   141,   142,   696,   100,    71,   697,
      94,    95,    96,    97,    98,   515,   516,   143,    99,   100,
     144,   145,   146,   147,   148,   149,    79,    40,   698,    42,
     322,   699,   150,   151,   210,   323,    91,   183,   184,   150,
     152,   101,   102,   795,    44,   209,   796,   210,   230,   211,
     212,   231,   232,    46,   103,    48,   338,   104,    91,   183,
     184,   339,   648,   649,   105,   106,   100,   210,   107,   560,
     342,   210,    79,   211,   212,   343,    75,   213,   214,   215,
     823,    50,    52,   824,   372,    76,    77,    78,   100,   373,
     424,   563,   564,   565,   566,    54,   528,   529,   530,    79,
      79,    28,    29,    30,    31,   797,   284,   798,   799,   388,
     285,   185,    79,   286,   389,   186,   187,   188,   189,   190,
     191,   567,   192,   577,   287,   288,    79,   294,   298,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,    79,
     634,   635,   636,   637,   638,   639,   317,   670,   354,   210,
     299,   668,   671,   749,   303,   429,   430,   322,   355,    79,
     304,   305,   672,    79,     1,     2,     3,     4,     5,     6,
       7,     8,     9,    10,    11,   684,   363,    80,   684,   709,
     685,    79,   306,   686,   710,   314,   321,   390,   391,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   713,   388,   364,   425,   338,   714,   715,
     426,   372,   781,   428,   332,   333,   784,   427,   154,   155,
     153,   342,   368,   811,   177,   840,   788,   173,   812,   358,
     841,   170,    79,   362,   366,   178,   367,   193,   156,   157,
     369,    79,   374,   377,   198,   379,   216,   380,   194,   383,
     392,   233,   384,   385,   393,   234,   394,   235,   395,   396,
     397,   236,   616,   617,   618,   619,   399,   620,   402,   403,
     267,   770,   771,   772,   773,   774,   400,   401,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   420,   421,   436,   422,   497,   498,   499,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   450,   451,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   464,   465,   466,   467,   468,   469,
     470,   472,   473,   474,   476,   477,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   491,   492,   494,   488,   501,
     489,   490,   495,   496,   500,   502,   503,   504,   505,   506,
     507,   508,   509,   521,   735,   510,   511,   512,   513,   519,
     520,   524,   534,   522,   533,   523,   525,   526,   527,   555,
      26,   562,   532,   604,   588,   588,   535,   608,   596,   596,
     612,   572,   630,   538,   267,   539,   570,   656,   658,   541,
     542,   543,   425,   544,   662,   545,   426,   677,   546,   428,
     547,   548,   549,   427,   550,   551,   678,   552,   553,   554,
     556,   666,   679,   680,   681,   689,   540,   688,   557,   691,
     692,   694,   695,   769,   558,   569,   701,   702,   721,   703,
     704,   705,   706,   707,   708,   716,   722,   724,   725,   763,
     727,   728,   730,   731,   732,   733,   739,   740,   759,   760,
     536,   768,   762,   571,   719,   809,   782,   783,   789,   734,
     791,   736,   813,   815,   737,   738,   817,   819,   752,   837,
     753,   838,   839,   842,   398,   576,   419,   754,   423,   603,
     741,   748,   751,   755,   756,   758,   750,   478,   743,   742,
     745,   744,   449,   746,   475,   757,   776,   765,   747,   471,
     777,   764,   778,   779,   780,   452,   785,   786,   767,   787,
     790,   766,   814,   818,   657,   463,   847,   843,   761,   844,
     845,   654,   729,   807,   816,   835,   493,   846,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   588,   154,   155,   153,
     596,     0,   216,     0,     0,   233,   173,     0,     0,   234,
     170,   235,   248,     0,     0,   236,     0,   156,   157,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   177,     0,     0,   193,     0,     0,     0,     0,
       0,     0,   198,   178,     0,     0,   194,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   800,     0,     0,     0,
     801,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   800,     0,     0,     0,   801
  };

  const short int
  Dhcp4Parser::yycheck_[] =
  {
      58,    61,    61,    61,    62,    63,    64,    65,    66,    67,
      61,    65,    63,    65,    61,    62,    63,    65,    56,   324,
     324,    61,    61,   508,     5,     7,     7,    10,     9,    85,
      86,    15,     7,     0,    12,    13,    18,    19,    16,    49,
     122,    11,     7,   125,   126,   127,     7,    17,    18,    19,
      60,    61,    22,    23,    85,    86,     3,     3,    40,    41,
      42,     8,     8,    45,    46,    47,     3,    49,   142,     6,
      40,    41,    42,    43,    44,    14,    15,    59,    48,    49,
      62,    63,    64,    65,    66,    67,   142,     7,     3,     7,
       3,     6,    74,    75,    50,     8,    19,    20,    21,    74,
      82,    71,    72,     3,     7,    24,     6,    50,    51,    52,
      53,    54,    55,     7,    84,     7,     3,    87,    19,    20,
      21,     8,    96,    97,    94,    95,    49,    50,    98,   113,
       3,    50,   142,    52,    53,     8,   119,    56,    57,    58,
       3,     7,     7,     6,     3,   128,   129,   130,    49,     8,
      73,   115,   116,   117,   118,     7,    68,    69,    70,   142,
     142,   142,   143,   144,   145,   121,     6,   123,   124,     3,
       3,    72,   142,     4,     8,    76,    77,    78,    79,    80,
      81,   145,    83,    24,     8,     3,   142,     4,     4,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,   142,
      88,    89,    90,    91,    92,    93,     3,     3,     8,    50,
       4,     8,     8,   698,     4,   520,   520,     3,     3,   142,
       4,     4,     8,   142,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,     3,     8,   295,     3,     3,
       8,   142,     4,     8,     8,     4,     4,   285,   286,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,     3,     3,     3,   324,     3,     8,     8,
     324,     3,     8,   324,     4,     4,     8,   324,   338,   338,
     338,     3,     8,     3,   342,     3,     8,   338,     8,     4,
       8,   338,   142,     4,     4,   342,     4,   355,   338,   338,
       3,   142,     4,     4,   355,     4,   364,     4,   355,     4,
     142,   369,     4,     4,     4,   369,     4,   369,     4,     4,
       4,   369,    76,    77,    78,    79,     4,    81,     4,     4,
     388,    25,    26,    27,    28,    29,   145,   145,     4,   143,
     143,   143,   143,     4,     4,     4,     4,     4,     4,     4,
     143,     4,     4,     4,     4,     4,   145,   395,   396,   397,
       4,     4,     4,     4,     4,     4,   143,   145,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,   143,     4,     4,     4,
     145,     4,   145,   145,     4,     4,   145,     4,     4,   143,
       4,   143,   143,     4,     4,     4,     4,     4,   145,   142,
     145,   145,     7,     7,     7,     7,     7,     5,     5,     5,
       5,     5,     5,   142,   145,     7,     7,     7,     5,     8,
       3,     5,     7,   142,     5,   142,   142,   142,   142,   477,
       7,   114,   142,     7,   502,   503,   142,     7,   502,   503,
       7,   120,     7,   142,   512,   142,   494,     4,     7,   142,
     142,   142,   520,   142,     7,   142,   520,     4,   142,   520,
     142,   142,   142,   520,   142,   142,     4,   142,   142,   142,
     142,    83,     4,     4,     4,     3,   455,     6,   142,     6,
       3,     6,     3,     5,   142,   142,     6,     3,     6,     4,
       4,     4,     4,     4,     4,   142,     3,     6,     3,     3,
       8,     4,     4,     4,     4,     4,     4,     4,     4,     4,
     451,     4,     6,   495,   142,     4,     8,     8,     8,   143,
       7,   143,     4,     4,   145,   143,     5,     7,   143,     4,
     143,     4,     4,     4,   295,   500,   317,   143,   322,   503,
     684,   696,   702,   143,   143,   709,   700,   372,   689,   687,
     692,   690,   338,   693,   369,   143,   142,   722,   695,   364,
     142,   720,   142,   142,   142,   342,   142,   142,   725,   142,
     142,   723,   143,   142,   520,   355,   142,   145,   713,   143,
     143,   512,   670,   795,   811,   823,   388,   840,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   684,   687,   687,   687,
     684,    -1,   690,    -1,    -1,   693,   687,    -1,    -1,   693,
     687,   693,   700,    -1,    -1,   693,    -1,   687,   687,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   720,    -1,    -1,   723,    -1,    -1,    -1,    -1,
      -1,    -1,   723,   720,    -1,    -1,   723,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   794,    -1,    -1,    -1,
     794,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   811,    -1,    -1,    -1,   811
  };

  const unsigned short int
  Dhcp4Parser::yystos_[] =
  {
       0,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,     0,     5,     7,     9,   142,   143,
     144,   145,   159,   160,   161,   166,     7,   175,     7,   181,
       7,   195,     7,   268,     7,   339,     7,   353,     7,   297,
       7,   321,     7,   244,     7,   405,   167,   162,   176,   182,
     196,   269,   340,   354,   298,   322,   245,   406,   159,   168,
     169,   142,   164,   165,    10,   119,   128,   129,   130,   142,
     174,   177,   178,   179,   432,   434,   436,   438,    11,    17,
      18,    19,    22,    23,    40,    41,    42,    43,    44,    48,
      49,    71,    72,    84,    87,    94,    95,    98,   174,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   203,   205,
     229,   238,   252,   262,   291,   315,   358,   384,   394,   395,
     403,    12,    13,    16,   193,   194,   197,   199,   202,     7,
      45,    46,    47,    59,    62,    63,    64,    65,    66,    67,
      74,    75,    82,   174,   185,   186,   187,   190,   270,   271,
     272,   274,   276,   278,   280,   282,   284,   286,   289,   290,
     315,   333,   347,   358,   380,    60,    61,   174,   315,   341,
     342,   343,   345,    20,    21,    72,    76,    77,    78,    79,
      80,    81,    83,   174,   315,   355,   356,   357,   358,   360,
     362,   364,   366,   368,   370,   372,   374,   376,   378,    24,
      50,    52,    53,    56,    57,    58,   174,   219,   299,   300,
     301,   302,   303,   304,   305,   307,   309,   311,   312,   314,
      51,    54,    55,   174,   219,   303,   309,   323,   324,   325,
     326,   327,   329,   330,   331,   332,    85,    86,   174,   246,
     247,   248,   250,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   174,   407,   408,
     409,   410,   412,   414,   415,   417,   418,   419,   422,   424,
     425,   426,   427,   430,     6,     3,     4,     8,     3,   180,
     439,   433,   435,   437,     4,     3,     8,   192,     4,     4,
     359,   204,   206,     4,     4,     4,     4,   263,   292,   316,
     230,   385,   239,   253,     4,   396,   404,     3,     8,   198,
     200,     4,     3,     8,   387,   275,   277,   279,   334,   273,
     281,   283,     4,     4,   287,   285,   348,   381,     3,     8,
     344,   346,     3,     8,   361,   363,   379,   367,   369,   373,
     371,   377,   375,   365,     8,     3,   306,   220,     4,   310,
     308,   313,     4,     8,     3,   328,     4,     4,     8,     3,
     249,   251,     3,     8,     4,   411,   413,     4,   416,     4,
       4,   420,   423,     4,     4,     4,   428,   431,     3,     8,
     159,   159,   142,     4,     4,     4,     4,     4,   178,     4,
     145,   145,     4,     4,     4,   143,   143,   143,   143,     4,
       4,     4,     4,     4,     4,     4,   143,     4,     4,   184,
       4,     4,   145,   194,    73,   174,   219,   315,   358,   360,
     362,   388,   389,   390,   391,   392,     4,     4,     4,     4,
       4,     4,     4,   143,   145,     4,     4,     4,     4,   271,
       4,     4,   342,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,   357,     4,     4,   143,     4,     4,     4,
     145,   301,     4,   145,   145,   325,     4,     4,   247,   145,
       4,     4,   143,     4,   143,   143,     4,     4,   145,   145,
     145,     4,     4,   408,     4,     7,     7,   159,   159,   159,
       7,   142,     7,     7,     5,     5,     5,     5,     5,     5,
       7,     7,     7,     5,   170,    14,    15,   201,   393,     8,
       3,   142,   142,   142,     5,   142,   142,   142,    68,    69,
      70,   288,   142,     5,     7,   142,   161,   163,   142,   142,
     170,   142,   142,   142,   142,   142,   142,   142,   142,   142,
     142,   142,   142,   142,   142,   159,   142,   142,   142,    15,
     113,   421,   114,   115,   116,   117,   118,   145,   429,   142,
     159,   183,   120,   440,   441,   442,   193,    24,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,   174,   207,
     208,   209,   212,   214,   216,   218,   219,   221,   222,   223,
     224,   225,   227,   207,     7,   264,   265,   266,     7,   293,
     294,   295,     7,   317,   318,   319,    76,    77,    78,    79,
      81,   231,   232,   233,   234,   235,   236,   237,   284,   386,
       7,   240,   241,   242,    88,    89,    90,    91,    92,    93,
     254,   255,   256,   257,   258,   259,   260,   261,    96,    97,
     397,   398,   399,   401,   407,   171,     4,   390,     7,   335,
     336,   337,     7,   349,   350,   351,    83,   382,     8,   443,
       3,     8,     8,   210,   213,   215,   217,     4,     4,     4,
       4,     4,   226,   228,     3,     8,     8,   267,     6,     3,
     296,     6,     3,   320,     6,     3,     3,     6,     3,     6,
     243,     6,     3,     4,     4,     4,     4,     4,     4,     3,
       8,   400,   402,     3,     8,     8,   142,   172,   173,   142,
     338,     6,     3,   352,     6,     3,   383,     8,     4,   441,
       4,     4,     4,     4,   143,   145,   143,   145,   143,     4,
       4,   208,   270,   266,   299,   295,   323,   319,   232,   284,
     246,   242,   143,   143,   143,   143,   143,   143,   255,     4,
       4,   398,     6,     3,   341,   337,   355,   351,     4,     5,
      25,    26,    27,    28,    29,   211,   142,   142,   142,   142,
     142,     8,     8,     8,     8,   142,   142,   142,     8,     8,
     142,     7,   444,   445,   446,     3,     6,   121,   123,   124,
     174,   219,   447,   448,   449,   450,   452,   445,   453,     4,
     451,     3,     8,     4,   143,     4,   448,     5,   142,     7,
     454,   455,   456,     3,     6,   122,   125,   126,   127,   457,
     458,   459,   461,   462,   463,   455,   460,     4,     4,     4,
       3,     8,     4,   145,   143,   143,   458,   142
  };

  const unsigned short int
  Dhcp4Parser::yyr1_[] =
  {
       0,   146,   148,   147,   149,   147,   150,   147,   151,   147,
     152,   147,   153,   147,   154,   147,   155,   147,   156,   147,
     157,   147,   158,   147,   159,   159,   159,   159,   159,   159,
     159,   160,   162,   161,   163,   164,   164,   165,   165,   167,
     166,   168,   168,   169,   169,   171,   170,   172,   172,   173,
     173,   174,   176,   175,   177,   177,   178,   178,   178,   178,
     178,   178,   180,   179,   182,   181,   183,   183,   184,   184,
     184,   184,   184,   184,   184,   184,   184,   184,   184,   184,
     184,   184,   184,   184,   184,   184,   184,   184,   184,   185,
     186,   187,   188,   189,   190,   192,   191,   193,   193,   194,
     194,   194,   196,   195,   198,   197,   200,   199,   201,   201,
     202,   204,   203,   206,   205,   207,   207,   208,   208,   208,
     208,   208,   208,   208,   208,   208,   208,   208,   208,   208,
     210,   209,   211,   211,   211,   211,   211,   213,   212,   215,
     214,   217,   216,   218,   220,   219,   221,   222,   223,   224,
     226,   225,   228,   227,   230,   229,   231,   231,   232,   232,
     232,   232,   232,   233,   234,   235,   236,   237,   239,   238,
     240,   240,   241,   241,   243,   242,   245,   244,   246,   246,
     246,   247,   247,   249,   248,   251,   250,   253,   252,   254,
     254,   255,   255,   255,   255,   255,   255,   256,   257,   258,
     259,   260,   261,   263,   262,   264,   264,   265,   265,   267,
     266,   269,   268,   270,   270,   271,   271,   271,   271,   271,
     271,   271,   271,   271,   271,   271,   271,   271,   271,   271,
     271,   271,   271,   271,   271,   273,   272,   275,   274,   277,
     276,   279,   278,   281,   280,   283,   282,   285,   284,   287,
     286,   288,   288,   288,   289,   290,   292,   291,   293,   293,
     294,   294,   296,   295,   298,   297,   299,   299,   300,   300,
     301,   301,   301,   301,   301,   301,   301,   301,   302,   303,
     304,   306,   305,   308,   307,   310,   309,   311,   313,   312,
     314,   316,   315,   317,   317,   318,   318,   320,   319,   322,
     321,   323,   323,   324,   324,   325,   325,   325,   325,   325,
     325,   325,   326,   328,   327,   329,   330,   331,   332,   334,
     333,   335,   335,   336,   336,   338,   337,   340,   339,   341,
     341,   342,   342,   342,   342,   344,   343,   346,   345,   348,
     347,   349,   349,   350,   350,   352,   351,   354,   353,   355,
     355,   356,   356,   357,   357,   357,   357,   357,   357,   357,
     357,   357,   357,   357,   357,   357,   359,   358,   361,   360,
     363,   362,   365,   364,   367,   366,   369,   368,   371,   370,
     373,   372,   375,   374,   377,   376,   379,   378,   381,   380,
     383,   382,   385,   384,   386,   386,   387,   284,   388,   388,
     389,   389,   390,   390,   390,   390,   390,   390,   390,   391,
     393,   392,   394,   396,   395,   397,   397,   398,   398,   400,
     399,   402,   401,   404,   403,   406,   405,   407,   407,   408,
     408,   408,   408,   408,   408,   408,   408,   408,   408,   408,
     408,   408,   408,   408,   409,   411,   410,   413,   412,   414,
     416,   415,   417,   418,   420,   419,   421,   421,   423,   422,
     424,   425,   426,   428,   427,   429,   429,   429,   429,   429,
     431,   430,   433,   432,   435,   434,   437,   436,   439,   438,
     440,   440,   441,   443,   442,   444,   444,   446,   445,   447,
     447,   448,   448,   448,   448,   448,   449,   451,   450,   453,
     452,   454,   454,   456,   455,   457,   457,   458,   458,   458,
     458,   460,   459,   461,   462,   463
  };

  const unsigned char
  Dhcp4Parser::yyr2_[] =
  {
       0,     2,     0,     3,     0,     3,     0,     3,     0,     3,
       0,     3,     0,     3,     0,     3,     0,     3,     0,     3,
       0,     3,     0,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     0,     4,     1,     0,     1,     3,     5,     0,
       4,     0,     1,     1,     3,     0,     4,     0,     1,     1,
       3,     2,     0,     4,     1,     3,     1,     1,     1,     1,
       1,     1,     0,     6,     0,     4,     1,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       3,     3,     3,     3,     3,     0,     6,     1,     3,     1,
       1,     1,     0,     4,     0,     4,     0,     4,     1,     1,
       3,     0,     6,     0,     6,     1,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       0,     4,     1,     1,     1,     1,     1,     0,     4,     0,
       4,     0,     4,     3,     0,     4,     3,     3,     3,     3,
       0,     4,     0,     4,     0,     6,     1,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     0,     6,
       0,     1,     1,     3,     0,     4,     0,     4,     1,     3,
       1,     1,     1,     0,     4,     0,     4,     0,     6,     1,
       3,     1,     1,     1,     1,     1,     1,     3,     3,     3,
       3,     3,     3,     0,     6,     0,     1,     1,     3,     0,
       4,     0,     4,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     0,     4,     0,     4,     0,
       4,     0,     4,     0,     4,     0,     4,     0,     4,     0,
       4,     1,     1,     1,     3,     3,     0,     6,     0,     1,
       1,     3,     0,     4,     0,     4,     0,     1,     1,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       1,     0,     4,     0,     4,     0,     4,     1,     0,     4,
       3,     0,     6,     0,     1,     1,     3,     0,     4,     0,
       4,     0,     1,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     0,     4,     1,     1,     3,     3,     0,
       6,     0,     1,     1,     3,     0,     4,     0,     4,     1,
       3,     1,     1,     1,     1,     0,     4,     0,     4,     0,
       6,     0,     1,     1,     3,     0,     4,     0,     4,     0,
       1,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     4,     0,     4,
       0,     4,     0,     4,     0,     4,     0,     4,     0,     4,
       0,     4,     0,     4,     0,     4,     0,     4,     0,     6,
       0,     4,     0,     6,     1,     3,     0,     4,     0,     1,
       1,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       0,     4,     3,     0,     6,     1,     3,     1,     1,     0,
       4,     0,     4,     0,     6,     0,     4,     1,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     0,     4,     0,     4,     3,
       0,     4,     3,     3,     0,     4,     1,     1,     0,     4,
       3,     3,     3,     0,     4,     1,     1,     1,     1,     1,
       0,     4,     0,     4,     0,     4,     0,     4,     0,     6,
       1,     3,     1,     0,     6,     1,     3,     0,     4,     1,
       3,     1,     1,     1,     1,     1,     3,     0,     4,     0,
       6,     1,     3,     0,     4,     1,     3,     1,     1,     1,
       1,     0,     4,     3,     3,     3
  };



  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a yyntokens_, nonterminals.
  const char*
  const Dhcp4Parser::yytname_[] =
  {
  "\"end of file\"", "error", "$undefined", "\",\"", "\":\"", "\"[\"",
  "\"]\"", "\"{\"", "\"}\"", "\"null\"", "\"Dhcp4\"",
  "\"interfaces-config\"", "\"interfaces\"", "\"dhcp-socket-type\"",
  "\"raw\"", "\"udp\"", "\"re-detect\"", "\"echo-client-id\"",
  "\"match-client-id\"", "\"next-server\"", "\"server-hostname\"",
  "\"boot-file-name\"", "\"lease-database\"", "\"hosts-database\"",
  "\"type\"", "\"memfile\"", "\"mysql\"", "\"postgresql\"", "\"cql\"",
  "\"radius\"", "\"user\"", "\"password\"", "\"host\"", "\"port\"",
  "\"persist\"", "\"lfc-interval\"", "\"readonly\"", "\"connect-timeout\"",
  "\"contact-points\"", "\"keyspace\"", "\"valid-lifetime\"",
  "\"renew-timer\"", "\"rebind-timer\"", "\"decline-probation-period\"",
  "\"subnet4\"", "\"4o6-interface\"", "\"4o6-interface-id\"",
  "\"4o6-subnet\"", "\"option-def\"", "\"option-data\"", "\"name\"",
  "\"data\"", "\"code\"", "\"space\"", "\"csv-format\"", "\"always-send\"",
  "\"record-types\"", "\"encapsulate\"", "\"array\"", "\"pools\"",
  "\"pool\"", "\"user-context\"", "\"subnet\"", "\"interface\"",
  "\"interface-id\"", "\"id\"", "\"rapid-commit\"", "\"reservation-mode\"",
  "\"disabled\"", "\"out-of-pool\"", "\"all\"",
  "\"host-reservation-identifiers\"", "\"client-classes\"", "\"test\"",
  "\"client-class\"", "\"reservations\"", "\"duid\"", "\"hw-address\"",
  "\"circuit-id\"", "\"client-id\"", "\"hostname\"", "\"flex-id\"",
  "\"relay\"", "\"ip-address\"", "\"hooks-libraries\"", "\"library\"",
  "\"parameters\"", "\"expired-leases-processing\"",
  "\"reclaim-timer-wait-time\"", "\"flush-reclaimed-timer-wait-time\"",
  "\"hold-reclaimed-time\"", "\"max-reclaim-leases\"",
  "\"max-reclaim-time\"", "\"unwarned-reclaim-cycles\"",
  "\"dhcp4o6-port\"", "\"control-socket\"", "\"socket-type\"",
  "\"socket-name\"", "\"dhcp-ddns\"", "\"enable-updates\"",
  "\"qualifying-suffix\"", "\"server-ip\"", "\"server-port\"",
  "\"sender-ip\"", "\"sender-port\"", "\"max-queue-size\"",
  "\"ncr-protocol\"", "\"ncr-format\"", "\"always-include-fqdn\"",
  "\"override-no-update\"", "\"override-client-update\"",
  "\"replace-client-name\"", "\"generated-prefix\"", "\"tcp\"", "\"JSON\"",
  "\"when-present\"", "\"never\"", "\"always\"", "\"when-not-present\"",
  "\"Logging\"", "\"loggers\"", "\"output_options\"", "\"output\"",
  "\"debuglevel\"", "\"severity\"", "\"flush\"", "\"maxsize\"",
  "\"maxver\"", "\"Dhcp6\"", "\"DhcpDdns\"", "\"Control-agent\"",
  "TOPLEVEL_JSON", "TOPLEVEL_DHCP4", "SUB_DHCP4", "SUB_INTERFACES4",
  "SUB_SUBNET4", "SUB_POOL4", "SUB_RESERVATION", "SUB_OPTION_DEF",
  "SUB_OPTION_DATA", "SUB_HOOKS_LIBRARY", "SUB_DHCP_DDNS",
  "\"constant string\"", "\"integer\"", "\"floating point\"",
  "\"boolean\"", "$accept", "start", "$@1", "$@2", "$@3", "$@4", "$@5",
  "$@6", "$@7", "$@8", "$@9", "$@10", "$@11", "value", "sub_json", "map2",
  "$@12", "map_value", "map_content", "not_empty_map", "list_generic",
  "$@13", "list_content", "not_empty_list", "list_strings", "$@14",
  "list_strings_content", "not_empty_list_strings", "unknown_map_entry",
  "syntax_map", "$@15", "global_objects", "global_object", "dhcp4_object",
  "$@16", "sub_dhcp4", "$@17", "global_params", "global_param",
  "valid_lifetime", "renew_timer", "rebind_timer",
  "decline_probation_period", "echo_client_id", "match_client_id",
  "interfaces_config", "$@18", "interfaces_config_params",
  "interfaces_config_param", "sub_interfaces4", "$@19", "interfaces_list",
  "$@20", "dhcp_socket_type", "$@21", "socket_type", "re_detect",
  "lease_database", "$@22", "hosts_database", "$@23",
  "database_map_params", "database_map_param", "database_type", "$@24",
  "db_type", "user", "$@25", "password", "$@26", "host", "$@27", "port",
  "name", "$@28", "persist", "lfc_interval", "readonly", "connect_timeout",
  "contact_points", "$@29", "keyspace", "$@30",
  "host_reservation_identifiers", "$@31",
  "host_reservation_identifiers_list", "host_reservation_identifier",
  "duid_id", "hw_address_id", "circuit_id", "client_id", "flex_id",
  "hooks_libraries", "$@32", "hooks_libraries_list",
  "not_empty_hooks_libraries_list", "hooks_library", "$@33",
  "sub_hooks_library", "$@34", "hooks_params", "hooks_param", "library",
  "$@35", "parameters", "$@36", "expired_leases_processing", "$@37",
  "expired_leases_params", "expired_leases_param",
  "reclaim_timer_wait_time", "flush_reclaimed_timer_wait_time",
  "hold_reclaimed_time", "max_reclaim_leases", "max_reclaim_time",
  "unwarned_reclaim_cycles", "subnet4_list", "$@38",
  "subnet4_list_content", "not_empty_subnet4_list", "subnet4", "$@39",
  "sub_subnet4", "$@40", "subnet4_params", "subnet4_param", "subnet",
  "$@41", "subnet_4o6_interface", "$@42", "subnet_4o6_interface_id",
  "$@43", "subnet_4o6_subnet", "$@44", "interface", "$@45", "interface_id",
  "$@46", "client_class", "$@47", "reservation_mode", "$@48", "hr_mode",
  "id", "rapid_commit", "option_def_list", "$@49",
  "option_def_list_content", "not_empty_option_def_list",
  "option_def_entry", "$@50", "sub_option_def", "$@51",
  "option_def_params", "not_empty_option_def_params", "option_def_param",
  "option_def_name", "code", "option_def_code", "option_def_type", "$@52",
  "option_def_record_types", "$@53", "space", "$@54", "option_def_space",
  "option_def_encapsulate", "$@55", "option_def_array", "option_data_list",
  "$@56", "option_data_list_content", "not_empty_option_data_list",
  "option_data_entry", "$@57", "sub_option_data", "$@58",
  "option_data_params", "not_empty_option_data_params",
  "option_data_param", "option_data_name", "option_data_data", "$@59",
  "option_data_code", "option_data_space", "option_data_csv_format",
  "option_data_always_send", "pools_list", "$@60", "pools_list_content",
  "not_empty_pools_list", "pool_list_entry", "$@61", "sub_pool4", "$@62",
  "pool_params", "pool_param", "pool_entry", "$@63", "user_context",
  "$@64", "reservations", "$@65", "reservations_list",
  "not_empty_reservations_list", "reservation", "$@66", "sub_reservation",
  "$@67", "reservation_params", "not_empty_reservation_params",
  "reservation_param", "next_server", "$@68", "server_hostname", "$@69",
  "boot_file_name", "$@70", "ip_address", "$@71", "duid", "$@72",
  "hw_address", "$@73", "client_id_value", "$@74", "circuit_id_value",
  "$@75", "flex_id_value", "$@76", "hostname", "$@77",
  "reservation_client_classes", "$@78", "relay", "$@79", "relay_map",
  "$@80", "client_classes", "$@81", "client_classes_list", "$@82",
  "client_class_params", "not_empty_client_class_params",
  "client_class_param", "client_class_name", "client_class_test", "$@83",
  "dhcp4o6_port", "control_socket", "$@84", "control_socket_params",
  "control_socket_param", "control_socket_type", "$@85",
  "control_socket_name", "$@86", "dhcp_ddns", "$@87", "sub_dhcp_ddns",
  "$@88", "dhcp_ddns_params", "dhcp_ddns_param", "enable_updates",
  "qualifying_suffix", "$@89", "server_ip", "$@90", "server_port",
  "sender_ip", "$@91", "sender_port", "max_queue_size", "ncr_protocol",
  "$@92", "ncr_protocol_value", "ncr_format", "$@93",
  "always_include_fqdn", "override_no_update", "override_client_update",
  "replace_client_name", "$@94", "replace_client_name_value",
  "generated_prefix", "$@95", "dhcp6_json_object", "$@96",
  "dhcpddns_json_object", "$@97", "control_agent_json_object", "$@98",
  "logging_object", "$@99", "logging_params", "logging_param", "loggers",
  "$@100", "loggers_entries", "logger_entry", "$@101", "logger_params",
  "logger_param", "debuglevel", "severity", "$@102", "output_options_list",
  "$@103", "output_options_list_content", "output_entry", "$@104",
  "output_params_list", "output_params", "output", "$@105", "flush",
  "maxsize", "maxver", YY_NULLPTR
  };

#if PARSER4_DEBUG
  const unsigned short int
  Dhcp4Parser::yyrline_[] =
  {
       0,   227,   227,   227,   228,   228,   229,   229,   230,   230,
     231,   231,   232,   232,   233,   233,   234,   234,   235,   235,
     236,   236,   237,   237,   245,   246,   247,   248,   249,   250,
     251,   254,   259,   259,   270,   273,   274,   277,   281,   288,
     288,   295,   296,   299,   303,   310,   310,   317,   318,   321,
     325,   336,   346,   346,   359,   360,   364,   365,   366,   367,
     368,   369,   372,   372,   389,   389,   397,   398,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   426,
     431,   436,   441,   446,   451,   457,   457,   467,   468,   471,
     472,   473,   476,   476,   484,   484,   494,   494,   501,   502,
     505,   511,   511,   521,   521,   531,   532,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     550,   550,   557,   558,   559,   560,   561,   564,   564,   572,
     572,   580,   580,   588,   593,   593,   601,   606,   611,   616,
     621,   621,   629,   629,   638,   638,   648,   649,   652,   653,
     654,   655,   656,   659,   664,   669,   674,   679,   684,   684,
     694,   695,   698,   699,   702,   702,   710,   710,   718,   719,
     720,   723,   724,   727,   727,   735,   735,   743,   743,   753,
     754,   757,   758,   759,   760,   761,   762,   765,   770,   775,
     780,   785,   790,   798,   798,   811,   812,   815,   816,   823,
     823,   846,   846,   855,   856,   860,   861,   862,   863,   864,
     865,   866,   867,   868,   869,   870,   871,   872,   873,   874,
     875,   876,   877,   878,   879,   882,   882,   890,   890,   898,
     898,   906,   906,   914,   914,   922,   922,   930,   930,   938,
     938,   945,   946,   947,   950,   955,   964,   964,   976,   977,
     980,   981,   986,   986,   997,   997,  1007,  1008,  1011,  1012,
    1015,  1016,  1017,  1018,  1019,  1020,  1021,  1022,  1025,  1027,
    1032,  1034,  1034,  1042,  1042,  1050,  1050,  1058,  1060,  1060,
    1068,  1077,  1077,  1089,  1090,  1095,  1096,  1101,  1101,  1112,
    1112,  1123,  1124,  1129,  1130,  1135,  1136,  1137,  1138,  1139,
    1140,  1141,  1144,  1146,  1146,  1154,  1156,  1158,  1163,  1171,
    1171,  1183,  1184,  1187,  1188,  1191,  1191,  1199,  1199,  1207,
    1208,  1211,  1212,  1213,  1214,  1217,  1217,  1225,  1225,  1235,
    1235,  1245,  1246,  1249,  1250,  1253,  1253,  1261,  1261,  1269,
    1270,  1273,  1274,  1278,  1279,  1280,  1281,  1282,  1283,  1284,
    1285,  1286,  1287,  1288,  1289,  1290,  1293,  1293,  1301,  1301,
    1309,  1309,  1317,  1317,  1325,  1325,  1333,  1333,  1341,  1341,
    1349,  1349,  1357,  1357,  1365,  1365,  1373,  1373,  1386,  1386,
    1396,  1396,  1407,  1407,  1417,  1418,  1421,  1421,  1429,  1430,
    1433,  1434,  1437,  1438,  1439,  1440,  1441,  1442,  1443,  1446,
    1448,  1448,  1460,  1467,  1467,  1477,  1478,  1481,  1482,  1485,
    1485,  1493,  1493,  1503,  1503,  1513,  1513,  1521,  1522,  1525,
    1526,  1527,  1528,  1529,  1530,  1531,  1532,  1533,  1534,  1535,
    1536,  1537,  1538,  1539,  1542,  1547,  1547,  1555,  1555,  1563,
    1568,  1568,  1576,  1581,  1586,  1586,  1594,  1595,  1598,  1598,
    1606,  1611,  1616,  1621,  1621,  1629,  1632,  1635,  1638,  1641,
    1647,  1647,  1657,  1657,  1664,  1664,  1671,  1671,  1683,  1683,
    1696,  1697,  1701,  1705,  1705,  1717,  1718,  1722,  1722,  1730,
    1731,  1734,  1735,  1736,  1737,  1738,  1741,  1746,  1746,  1754,
    1754,  1764,  1765,  1768,  1768,  1776,  1777,  1780,  1781,  1782,
    1783,  1786,  1786,  1794,  1799,  1804
  };

  // Print the state stack on the debug stream.
  void
  Dhcp4Parser::yystack_print_ ()
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << i->state;
    *yycdebug_ << std::endl;
  }

  // Report on the debug stream that the rule \a yyrule is going to be reduced.
  void
  Dhcp4Parser::yy_reduce_print_ (int yyrule)
  {
    unsigned int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):" << std::endl;
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // PARSER4_DEBUG


#line 14 "dhcp4_parser.yy" // lalr1.cc:1167
} } // isc::dhcp
#line 4192 "dhcp4_parser.cc" // lalr1.cc:1167
#line 1809 "dhcp4_parser.yy" // lalr1.cc:1168


void
isc::dhcp::Dhcp4Parser::error(const location_type& loc,
                              const std::string& what)
{
    ctx.error(loc, what);
}
