// A Bison parser, made by GNU Bison 3.0.4.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

// Take the name prefix into account.
#define yylex   parser6_lex

// First part of user declarations.

#line 39 "dhcp6_parser.cc" // lalr1.cc:404

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

#include "dhcp6_parser.h"

// User implementation prologue.

#line 53 "dhcp6_parser.cc" // lalr1.cc:412
// Unqualified %code blocks.
#line 34 "dhcp6_parser.yy" // lalr1.cc:413

#include <dhcp6/parser_context.h>

#line 59 "dhcp6_parser.cc" // lalr1.cc:413


#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K].location)
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (/*CONSTCOND*/ false)
# endif


// Suppress unused-variable warnings by "using" E.
#define YYUSE(E) ((void) (E))

// Enable debugging if requested.
#if PARSER6_DEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << std::endl;                  \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yystack_print_ ();                \
  } while (false)

#else // !PARSER6_DEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YYUSE(Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void>(0)
# define YY_STACK_PRINT()                static_cast<void>(0)

#endif // !PARSER6_DEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

#line 14 "dhcp6_parser.yy" // lalr1.cc:479
namespace isc { namespace dhcp {
#line 145 "dhcp6_parser.cc" // lalr1.cc:479

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
  Dhcp6Parser::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr = "";
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              // Fall through.
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }


  /// Build a parser object.
  Dhcp6Parser::Dhcp6Parser (isc::dhcp::Parser6Context& ctx_yyarg)
    :
#if PARSER6_DEBUG
      yydebug_ (false),
      yycdebug_ (&std::cerr),
#endif
      ctx (ctx_yyarg)
  {}

  Dhcp6Parser::~Dhcp6Parser ()
  {}


  /*---------------.
  | Symbol types.  |
  `---------------*/



  // by_state.
  inline
  Dhcp6Parser::by_state::by_state ()
    : state (empty_state)
  {}

  inline
  Dhcp6Parser::by_state::by_state (const by_state& other)
    : state (other.state)
  {}

  inline
  void
  Dhcp6Parser::by_state::clear ()
  {
    state = empty_state;
  }

  inline
  void
  Dhcp6Parser::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

  inline
  Dhcp6Parser::by_state::by_state (state_type s)
    : state (s)
  {}

  inline
  Dhcp6Parser::symbol_number_type
  Dhcp6Parser::by_state::type_get () const
  {
    if (state == empty_state)
      return empty_symbol;
    else
      return yystos_[state];
  }

  inline
  Dhcp6Parser::stack_symbol_type::stack_symbol_type ()
  {}


  inline
  Dhcp6Parser::stack_symbol_type::stack_symbol_type (state_type s, symbol_type& that)
    : super_type (s, that.location)
  {
      switch (that.type_get ())
    {
      case 168: // value
      case 172: // map_value
      case 216: // db_type
      case 292: // hr_mode
      case 413: // duid_type
      case 446: // ncr_protocol_value
      case 454: // replace_client_name_value
        value.move< ElementPtr > (that.value);
        break;

      case 153: // "boolean"
        value.move< bool > (that.value);
        break;

      case 152: // "floating point"
        value.move< double > (that.value);
        break;

      case 151: // "integer"
        value.move< int64_t > (that.value);
        break;

      case 150: // "constant string"
        value.move< std::string > (that.value);
        break;

      default:
        break;
    }

    // that is emptied.
    that.type = empty_symbol;
  }

  inline
  Dhcp6Parser::stack_symbol_type&
  Dhcp6Parser::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
      switch (that.type_get ())
    {
      case 168: // value
      case 172: // map_value
      case 216: // db_type
      case 292: // hr_mode
      case 413: // duid_type
      case 446: // ncr_protocol_value
      case 454: // replace_client_name_value
        value.copy< ElementPtr > (that.value);
        break;

      case 153: // "boolean"
        value.copy< bool > (that.value);
        break;

      case 152: // "floating point"
        value.copy< double > (that.value);
        break;

      case 151: // "integer"
        value.copy< int64_t > (that.value);
        break;

      case 150: // "constant string"
        value.copy< std::string > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    return *this;
  }


  template <typename Base>
  inline
  void
  Dhcp6Parser::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);
  }

#if PARSER6_DEBUG
  template <typename Base>
  void
  Dhcp6Parser::yy_print_ (std::ostream& yyo,
                                     const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YYUSE (yyoutput);
    symbol_number_type yytype = yysym.type_get ();
    // Avoid a (spurious) G++ 4.8 warning about "array subscript is
    // below array bounds".
    if (yysym.empty ())
      std::abort ();
    yyo << (yytype < yyntokens_ ? "token" : "nterm")
        << ' ' << yytname_[yytype] << " ("
        << yysym.location << ": ";
    switch (yytype)
    {
            case 150: // "constant string"

#line 226 "dhcp6_parser.yy" // lalr1.cc:636
        { yyoutput << yysym.value.template as< std::string > (); }
#line 364 "dhcp6_parser.cc" // lalr1.cc:636
        break;

      case 151: // "integer"

#line 226 "dhcp6_parser.yy" // lalr1.cc:636
        { yyoutput << yysym.value.template as< int64_t > (); }
#line 371 "dhcp6_parser.cc" // lalr1.cc:636
        break;

      case 152: // "floating point"

#line 226 "dhcp6_parser.yy" // lalr1.cc:636
        { yyoutput << yysym.value.template as< double > (); }
#line 378 "dhcp6_parser.cc" // lalr1.cc:636
        break;

      case 153: // "boolean"

#line 226 "dhcp6_parser.yy" // lalr1.cc:636
        { yyoutput << yysym.value.template as< bool > (); }
#line 385 "dhcp6_parser.cc" // lalr1.cc:636
        break;

      case 168: // value

#line 226 "dhcp6_parser.yy" // lalr1.cc:636
        { yyoutput << yysym.value.template as< ElementPtr > (); }
#line 392 "dhcp6_parser.cc" // lalr1.cc:636
        break;

      case 172: // map_value

#line 226 "dhcp6_parser.yy" // lalr1.cc:636
        { yyoutput << yysym.value.template as< ElementPtr > (); }
#line 399 "dhcp6_parser.cc" // lalr1.cc:636
        break;

      case 216: // db_type

#line 226 "dhcp6_parser.yy" // lalr1.cc:636
        { yyoutput << yysym.value.template as< ElementPtr > (); }
#line 406 "dhcp6_parser.cc" // lalr1.cc:636
        break;

      case 292: // hr_mode

#line 226 "dhcp6_parser.yy" // lalr1.cc:636
        { yyoutput << yysym.value.template as< ElementPtr > (); }
#line 413 "dhcp6_parser.cc" // lalr1.cc:636
        break;

      case 413: // duid_type

#line 226 "dhcp6_parser.yy" // lalr1.cc:636
        { yyoutput << yysym.value.template as< ElementPtr > (); }
#line 420 "dhcp6_parser.cc" // lalr1.cc:636
        break;

      case 446: // ncr_protocol_value

#line 226 "dhcp6_parser.yy" // lalr1.cc:636
        { yyoutput << yysym.value.template as< ElementPtr > (); }
#line 427 "dhcp6_parser.cc" // lalr1.cc:636
        break;

      case 454: // replace_client_name_value

#line 226 "dhcp6_parser.yy" // lalr1.cc:636
        { yyoutput << yysym.value.template as< ElementPtr > (); }
#line 434 "dhcp6_parser.cc" // lalr1.cc:636
        break;


      default:
        break;
    }
    yyo << ')';
  }
#endif

  inline
  void
  Dhcp6Parser::yypush_ (const char* m, state_type s, symbol_type& sym)
  {
    stack_symbol_type t (s, sym);
    yypush_ (m, t);
  }

  inline
  void
  Dhcp6Parser::yypush_ (const char* m, stack_symbol_type& s)
  {
    if (m)
      YY_SYMBOL_PRINT (m, s);
    yystack_.push (s);
  }

  inline
  void
  Dhcp6Parser::yypop_ (unsigned int n)
  {
    yystack_.pop (n);
  }

#if PARSER6_DEBUG
  std::ostream&
  Dhcp6Parser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  Dhcp6Parser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  Dhcp6Parser::debug_level_type
  Dhcp6Parser::debug_level () const
  {
    return yydebug_;
  }

  void
  Dhcp6Parser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // PARSER6_DEBUG

  inline Dhcp6Parser::state_type
  Dhcp6Parser::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - yyntokens_] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - yyntokens_];
  }

  inline bool
  Dhcp6Parser::yy_pact_value_is_default_ (int yyvalue)
  {
    return yyvalue == yypact_ninf_;
  }

  inline bool
  Dhcp6Parser::yy_table_value_is_error_ (int yyvalue)
  {
    return yyvalue == yytable_ninf_;
  }

  int
  Dhcp6Parser::parse ()
  {
    // State.
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[3];

    /// The return value of parse ().
    int yyresult;

    // FIXME: This shoud be completely indented.  It is not yet to
    // avoid gratuitous conflicts when merging into the master branch.
    try
      {
    YYCDEBUG << "Starting parse" << std::endl;


    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, yyla);

    // A new symbol was pushed on the stack.
  yynewstate:
    YYCDEBUG << "Entering state " << yystack_[0].state << std::endl;

    // Accept?
    if (yystack_[0].state == yyfinal_)
      goto yyacceptlab;

    goto yybackup;

    // Backup.
  yybackup:

    // Try to take a decision without lookahead.
    yyn = yypact_[yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token: ";
        try
          {
            symbol_type yylookahead (yylex (ctx));
            yyla.move (yylookahead);
          }
        catch (const syntax_error& yyexc)
          {
            error (yyexc);
            goto yyerrlab1;
          }
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.type_get ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.type_get ())
      goto yydefault;

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", yyn, yyla);
    goto yynewstate;

  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;

  /*-----------------------------.
  | yyreduce -- Do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_(yystack_[yylen].state, yyr1_[yyn]);
      /* Variants are always initialized to an empty instance of the
         correct type. The default '$$ = $1' action is NOT applied
         when using variants.  */
        switch (yyr1_[yyn])
    {
      case 168: // value
      case 172: // map_value
      case 216: // db_type
      case 292: // hr_mode
      case 413: // duid_type
      case 446: // ncr_protocol_value
      case 454: // replace_client_name_value
        yylhs.value.build< ElementPtr > ();
        break;

      case 153: // "boolean"
        yylhs.value.build< bool > ();
        break;

      case 152: // "floating point"
        yylhs.value.build< double > ();
        break;

      case 151: // "integer"
        yylhs.value.build< int64_t > ();
        break;

      case 150: // "constant string"
        yylhs.value.build< std::string > ();
        break;

      default:
        break;
    }


      // Compute the default @$.
      {
        slice<stack_symbol_type, stack_type> slice (yystack_, yylen);
        YYLLOC_DEFAULT (yylhs.location, slice, yylen);
      }

      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
      try
        {
          switch (yyn)
            {
  case 2:
#line 235 "dhcp6_parser.yy" // lalr1.cc:859
    { ctx.ctx_ = ctx.NO_KEYWORD; }
#line 680 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 4:
#line 236 "dhcp6_parser.yy" // lalr1.cc:859
    { ctx.ctx_ = ctx.CONFIG; }
#line 686 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 6:
#line 237 "dhcp6_parser.yy" // lalr1.cc:859
    { ctx.ctx_ = ctx.DHCP6; }
#line 692 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 8:
#line 238 "dhcp6_parser.yy" // lalr1.cc:859
    { ctx.ctx_ = ctx.INTERFACES_CONFIG; }
#line 698 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 10:
#line 239 "dhcp6_parser.yy" // lalr1.cc:859
    { ctx.ctx_ = ctx.SUBNET6; }
#line 704 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 12:
#line 240 "dhcp6_parser.yy" // lalr1.cc:859
    { ctx.ctx_ = ctx.POOLS; }
#line 710 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 14:
#line 241 "dhcp6_parser.yy" // lalr1.cc:859
    { ctx.ctx_ = ctx.PD_POOLS; }
#line 716 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 16:
#line 242 "dhcp6_parser.yy" // lalr1.cc:859
    { ctx.ctx_ = ctx.RESERVATIONS; }
#line 722 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 18:
#line 243 "dhcp6_parser.yy" // lalr1.cc:859
    { ctx.ctx_ = ctx.OPTION_DEF; }
#line 728 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 20:
#line 244 "dhcp6_parser.yy" // lalr1.cc:859
    { ctx.ctx_ = ctx.OPTION_DATA; }
#line 734 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 22:
#line 245 "dhcp6_parser.yy" // lalr1.cc:859
    { ctx.ctx_ = ctx.HOOKS_LIBRARIES; }
#line 740 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 24:
#line 246 "dhcp6_parser.yy" // lalr1.cc:859
    { ctx.ctx_ = ctx.DHCP_DDNS; }
#line 746 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 26:
#line 254 "dhcp6_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ElementPtr(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location))); }
#line 752 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 27:
#line 255 "dhcp6_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ElementPtr(new DoubleElement(yystack_[0].value.as< double > (), ctx.loc2pos(yystack_[0].location))); }
#line 758 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 28:
#line 256 "dhcp6_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ElementPtr(new BoolElement(yystack_[0].value.as< bool > (), ctx.loc2pos(yystack_[0].location))); }
#line 764 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 29:
#line 257 "dhcp6_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ElementPtr(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location))); }
#line 770 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 30:
#line 258 "dhcp6_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ElementPtr(new NullElement(ctx.loc2pos(yystack_[0].location))); }
#line 776 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 31:
#line 259 "dhcp6_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ctx.stack_.back(); ctx.stack_.pop_back(); }
#line 782 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 32:
#line 260 "dhcp6_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ctx.stack_.back(); ctx.stack_.pop_back(); }
#line 788 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 33:
#line 263 "dhcp6_parser.yy" // lalr1.cc:859
    {
    // Push back the JSON value on the stack
    ctx.stack_.push_back(yystack_[0].value.as< ElementPtr > ());
}
#line 797 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 34:
#line 268 "dhcp6_parser.yy" // lalr1.cc:859
    {
    // This code is executed when we're about to start parsing
    // the content of the map
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.push_back(m);
}
#line 808 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 35:
#line 273 "dhcp6_parser.yy" // lalr1.cc:859
    {
    // map parsing completed. If we ever want to do any wrap up
    // (maybe some sanity checking), this would be the best place
    // for it.
}
#line 818 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 36:
#line 279 "dhcp6_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ctx.stack_.back(); ctx.stack_.pop_back(); }
#line 824 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 39:
#line 286 "dhcp6_parser.yy" // lalr1.cc:859
    {
                  // map containing a single entry
                  ctx.stack_.back()->set(yystack_[2].value.as< std::string > (), yystack_[0].value.as< ElementPtr > ());
                  }
#line 833 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 40:
#line 290 "dhcp6_parser.yy" // lalr1.cc:859
    {
                  // map consisting of a shorter map followed by
                  // comma and string:value
                  ctx.stack_.back()->set(yystack_[2].value.as< std::string > (), yystack_[0].value.as< ElementPtr > ());
                  }
#line 843 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 41:
#line 297 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr l(new ListElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.push_back(l);
}
#line 852 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 42:
#line 300 "dhcp6_parser.yy" // lalr1.cc:859
    {
    // list parsing complete. Put any sanity checking here
}
#line 860 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 45:
#line 308 "dhcp6_parser.yy" // lalr1.cc:859
    {
                  // List consisting of a single element.
                  ctx.stack_.back()->add(yystack_[0].value.as< ElementPtr > ());
                  }
#line 869 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 46:
#line 312 "dhcp6_parser.yy" // lalr1.cc:859
    {
                  // List ending with , and a value.
                  ctx.stack_.back()->add(yystack_[0].value.as< ElementPtr > ());
                  }
#line 878 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 47:
#line 319 "dhcp6_parser.yy" // lalr1.cc:859
    {
    // List parsing about to start
}
#line 886 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 48:
#line 321 "dhcp6_parser.yy" // lalr1.cc:859
    {
    // list parsing complete. Put any sanity checking here
    //ctx.stack_.pop_back();
}
#line 895 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 51:
#line 330 "dhcp6_parser.yy" // lalr1.cc:859
    {
                          ElementPtr s(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
                          ctx.stack_.back()->add(s);
                          }
#line 904 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 52:
#line 334 "dhcp6_parser.yy" // lalr1.cc:859
    {
                          ElementPtr s(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
                          ctx.stack_.back()->add(s);
                          }
#line 913 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 53:
#line 345 "dhcp6_parser.yy" // lalr1.cc:859
    {
    const std::string& where = ctx.contextName();
    const std::string& keyword = yystack_[1].value.as< std::string > ();
    error(yystack_[1].location,
          "got unexpected keyword \"" + keyword + "\" in " + where + " map.");
}
#line 924 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 54:
#line 355 "dhcp6_parser.yy" // lalr1.cc:859
    {
    // This code is executed when we're about to start parsing
    // the content of the map
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.push_back(m);
}
#line 935 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 55:
#line 360 "dhcp6_parser.yy" // lalr1.cc:859
    {
    // map parsing completed. If we ever want to do any wrap up
    // (maybe some sanity checking), this would be the best place
    // for it.
}
#line 945 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 64:
#line 380 "dhcp6_parser.yy" // lalr1.cc:859
    {
    // This code is executed when we're about to start parsing
    // the content of the map
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("Dhcp6", m);
    ctx.stack_.push_back(m);
    ctx.enter(ctx.DHCP6);
}
#line 958 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 65:
#line 387 "dhcp6_parser.yy" // lalr1.cc:859
    {
    // map parsing completed. If we ever want to do any wrap up
    // (maybe some sanity checking), this would be the best place
    // for it.
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 970 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 66:
#line 397 "dhcp6_parser.yy" // lalr1.cc:859
    {
    // Parse the Dhcp6 map
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.push_back(m);
}
#line 980 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 67:
#line 401 "dhcp6_parser.yy" // lalr1.cc:859
    {
    // parsing completed
}
#line 988 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 92:
#line 435 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr prf(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("preferred-lifetime", prf);
}
#line 997 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 93:
#line 440 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr prf(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("valid-lifetime", prf);
}
#line 1006 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 94:
#line 445 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr prf(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("renew-timer", prf);
}
#line 1015 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 95:
#line 450 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr prf(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("rebind-timer", prf);
}
#line 1024 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 96:
#line 455 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr dpp(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("decline-probation-period", dpp);
}
#line 1033 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 97:
#line 460 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr i(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("interfaces-config", i);
    ctx.stack_.push_back(i);
    ctx.enter(ctx.INTERFACES_CONFIG);
}
#line 1044 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 98:
#line 465 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 1053 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 99:
#line 470 "dhcp6_parser.yy" // lalr1.cc:859
    {
    // Parse the interfaces-config map
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.push_back(m);
}
#line 1063 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 100:
#line 474 "dhcp6_parser.yy" // lalr1.cc:859
    {
    // parsing completed
}
#line 1071 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 105:
#line 486 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr l(new ListElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("interfaces", l);
    ctx.stack_.push_back(l);
    ctx.enter(ctx.NO_KEYWORD);
}
#line 1082 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 106:
#line 491 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 1091 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 107:
#line 496 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr b(new BoolElement(yystack_[0].value.as< bool > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("re-detect", b);
}
#line 1100 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 108:
#line 502 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr i(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("lease-database", i);
    ctx.stack_.push_back(i);
    ctx.enter(ctx.LEASE_DATABASE);
}
#line 1111 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 109:
#line 507 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 1120 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 110:
#line 512 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr i(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("hosts-database", i);
    ctx.stack_.push_back(i);
    ctx.enter(ctx.HOSTS_DATABASE);
}
#line 1131 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 111:
#line 517 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 1140 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 127:
#line 541 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.DATABASE_TYPE);
}
#line 1148 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 128:
#line 543 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.back()->set("type", yystack_[0].value.as< ElementPtr > ());
    ctx.leave();
}
#line 1157 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 129:
#line 548 "dhcp6_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ElementPtr(new StringElement("memfile", ctx.loc2pos(yystack_[0].location))); }
#line 1163 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 130:
#line 549 "dhcp6_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ElementPtr(new StringElement("mysql", ctx.loc2pos(yystack_[0].location))); }
#line 1169 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 131:
#line 550 "dhcp6_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ElementPtr(new StringElement("postgresql", ctx.loc2pos(yystack_[0].location))); }
#line 1175 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 132:
#line 551 "dhcp6_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ElementPtr(new StringElement("cql", ctx.loc2pos(yystack_[0].location))); }
#line 1181 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 133:
#line 552 "dhcp6_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ElementPtr(new StringElement("radius", ctx.loc2pos(yystack_[0].location))); }
#line 1187 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 134:
#line 555 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 1195 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 135:
#line 557 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr user(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("user", user);
    ctx.leave();
}
#line 1205 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 136:
#line 563 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 1213 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 137:
#line 565 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr pwd(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("password", pwd);
    ctx.leave();
}
#line 1223 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 138:
#line 571 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 1231 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 139:
#line 573 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr h(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("host", h);
    ctx.leave();
}
#line 1241 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 140:
#line 579 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr p(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("port", p);
}
#line 1250 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 141:
#line 584 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 1258 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 142:
#line 586 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr name(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("name", name);
    ctx.leave();
}
#line 1268 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 143:
#line 592 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr n(new BoolElement(yystack_[0].value.as< bool > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("persist", n);
}
#line 1277 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 144:
#line 597 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr n(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("lfc-interval", n);
}
#line 1286 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 145:
#line 602 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr n(new BoolElement(yystack_[0].value.as< bool > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("readonly", n);
}
#line 1295 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 146:
#line 607 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr n(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("connect-timeout", n);
}
#line 1304 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 147:
#line 612 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 1312 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 148:
#line 614 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr cp(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("contact-points", cp);
    ctx.leave();
}
#line 1322 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 149:
#line 620 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 1330 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 150:
#line 622 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr ks(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("keyspace", ks);
    ctx.leave();
}
#line 1340 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 151:
#line 629 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr l(new ListElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("mac-sources", l);
    ctx.stack_.push_back(l);
    ctx.enter(ctx.MAC_SOURCES);
}
#line 1351 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 152:
#line 634 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 1360 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 157:
#line 647 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr duid(new StringElement("duid", ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->add(duid);
}
#line 1369 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 158:
#line 652 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr duid(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->add(duid);
}
#line 1378 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 159:
#line 657 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr l(new ListElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("host-reservation-identifiers", l);
    ctx.stack_.push_back(l);
    ctx.enter(ctx.HOST_RESERVATION_IDENTIFIERS);
}
#line 1389 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 160:
#line 662 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 1398 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 166:
#line 676 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr hwaddr(new StringElement("hw-address", ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->add(hwaddr);
}
#line 1407 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 167:
#line 681 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr flex_id(new StringElement("flex-id", ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->add(flex_id);
}
#line 1416 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 168:
#line 688 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr l(new ListElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("relay-supplied-options", l);
    ctx.stack_.push_back(l);
    ctx.enter(ctx.NO_KEYWORD);
}
#line 1427 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 169:
#line 693 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 1436 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 170:
#line 698 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr l(new ListElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("hooks-libraries", l);
    ctx.stack_.push_back(l);
    ctx.enter(ctx.HOOKS_LIBRARIES);
}
#line 1447 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 171:
#line 703 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 1456 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 176:
#line 716 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->add(m);
    ctx.stack_.push_back(m);
}
#line 1466 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 177:
#line 720 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
}
#line 1474 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 178:
#line 724 "dhcp6_parser.yy" // lalr1.cc:859
    {
    // Parse the hooks-libraries list entry map
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.push_back(m);
}
#line 1484 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 179:
#line 728 "dhcp6_parser.yy" // lalr1.cc:859
    {
    // parsing completed
}
#line 1492 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 185:
#line 741 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 1500 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 186:
#line 743 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr lib(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("library", lib);
    ctx.leave();
}
#line 1510 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 187:
#line 749 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 1518 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 188:
#line 751 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.back()->set("parameters", yystack_[0].value.as< ElementPtr > ());
    ctx.leave();
}
#line 1527 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 189:
#line 757 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("expired-leases-processing", m);
    ctx.stack_.push_back(m);
    ctx.enter(ctx.EXPIRED_LEASES_PROCESSING);
}
#line 1538 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 190:
#line 762 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 1547 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 199:
#line 779 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr value(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("reclaim-timer-wait-time", value);
}
#line 1556 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 200:
#line 784 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr value(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("flush-reclaimed-timer-wait-time", value);
}
#line 1565 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 201:
#line 789 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr value(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("hold-reclaimed-time", value);
}
#line 1574 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 202:
#line 794 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr value(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("max-reclaim-leases", value);
}
#line 1583 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 203:
#line 799 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr value(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("max-reclaim-time", value);
}
#line 1592 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 204:
#line 804 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr value(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("unwarned-reclaim-cycles", value);
}
#line 1601 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 205:
#line 812 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr l(new ListElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("subnet6", l);
    ctx.stack_.push_back(l);
    ctx.enter(ctx.SUBNET6);
}
#line 1612 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 206:
#line 817 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 1621 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 211:
#line 837 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->add(m);
    ctx.stack_.push_back(m);
}
#line 1631 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 212:
#line 841 "dhcp6_parser.yy" // lalr1.cc:859
    {
    // Once we reached this place, the subnet parsing is now complete.
    // If we want to, we can implement default values here.
    // In particular we can do things like this:
    // if (!ctx.stack_.back()->get("interface")) {
    //     ctx.stack_.back()->set("interface", StringElement("loopback"));
    // }
    //
    // We can also stack up one level (Dhcp6) and copy over whatever
    // global parameters we want to:
    // if (!ctx.stack_.back()->get("renew-timer")) {
    //     ElementPtr renew = ctx_stack_[...].get("renew-timer");
    //     if (renew) {
    //         ctx.stack_.back()->set("renew-timer", renew);
    //     }
    // }
    ctx.stack_.pop_back();
}
#line 1654 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 213:
#line 860 "dhcp6_parser.yy" // lalr1.cc:859
    {
    // Parse the subnet6 list entry map
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.push_back(m);
}
#line 1664 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 214:
#line 864 "dhcp6_parser.yy" // lalr1.cc:859
    {
    // parsing completed
}
#line 1672 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 234:
#line 893 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 1680 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 235:
#line 895 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr subnet(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("subnet", subnet);
    ctx.leave();
}
#line 1690 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 236:
#line 901 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 1698 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 237:
#line 903 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr iface(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("interface", iface);
    ctx.leave();
}
#line 1708 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 238:
#line 909 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 1716 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 239:
#line 911 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr iface(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("interface-id", iface);
    ctx.leave();
}
#line 1726 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 240:
#line 917 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.CLIENT_CLASS);
}
#line 1734 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 241:
#line 919 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr cls(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("client-class", cls);
    ctx.leave();
}
#line 1744 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 242:
#line 925 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.RESERVATION_MODE);
}
#line 1752 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 243:
#line 927 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.back()->set("reservation-mode", yystack_[0].value.as< ElementPtr > ());
    ctx.leave();
}
#line 1761 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 244:
#line 932 "dhcp6_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ElementPtr(new StringElement("disabled", ctx.loc2pos(yystack_[0].location))); }
#line 1767 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 245:
#line 933 "dhcp6_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ElementPtr(new StringElement("out-of-pool", ctx.loc2pos(yystack_[0].location))); }
#line 1773 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 246:
#line 934 "dhcp6_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ElementPtr(new StringElement("all", ctx.loc2pos(yystack_[0].location))); }
#line 1779 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 247:
#line 937 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr id(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("id", id);
}
#line 1788 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 248:
#line 942 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr rc(new BoolElement(yystack_[0].value.as< bool > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("rapid-commit", rc);
}
#line 1797 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 249:
#line 951 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr l(new ListElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("option-def", l);
    ctx.stack_.push_back(l);
    ctx.enter(ctx.OPTION_DEF);
}
#line 1808 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 250:
#line 956 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 1817 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 255:
#line 973 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->add(m);
    ctx.stack_.push_back(m);
}
#line 1827 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 256:
#line 977 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
}
#line 1835 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 257:
#line 984 "dhcp6_parser.yy" // lalr1.cc:859
    {
    // Parse the option-def list entry map
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.push_back(m);
}
#line 1845 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 258:
#line 988 "dhcp6_parser.yy" // lalr1.cc:859
    {
    // parsing completed
}
#line 1853 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 272:
#line 1014 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr code(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("code", code);
}
#line 1862 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 274:
#line 1021 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 1870 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 275:
#line 1023 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr prf(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("type", prf);
    ctx.leave();
}
#line 1880 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 276:
#line 1029 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 1888 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 277:
#line 1031 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr rtypes(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("record-types", rtypes);
    ctx.leave();
}
#line 1898 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 278:
#line 1037 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 1906 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 279:
#line 1039 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr space(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("space", space);
    ctx.leave();
}
#line 1916 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 281:
#line 1047 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 1924 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 282:
#line 1049 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr encap(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("encapsulate", encap);
    ctx.leave();
}
#line 1934 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 283:
#line 1055 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr array(new BoolElement(yystack_[0].value.as< bool > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("array", array);
}
#line 1943 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 284:
#line 1064 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr l(new ListElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("option-data", l);
    ctx.stack_.push_back(l);
    ctx.enter(ctx.OPTION_DATA);
}
#line 1954 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 285:
#line 1069 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 1963 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 290:
#line 1088 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->add(m);
    ctx.stack_.push_back(m);
}
#line 1973 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 291:
#line 1092 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
}
#line 1981 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 292:
#line 1099 "dhcp6_parser.yy" // lalr1.cc:859
    {
    // Parse the option-data list entry map
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.push_back(m);
}
#line 1991 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 293:
#line 1103 "dhcp6_parser.yy" // lalr1.cc:859
    {
    // parsing completed
}
#line 1999 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 306:
#line 1133 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2007 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 307:
#line 1135 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr data(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("data", data);
    ctx.leave();
}
#line 2017 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 310:
#line 1145 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr space(new BoolElement(yystack_[0].value.as< bool > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("csv-format", space);
}
#line 2026 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 311:
#line 1150 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr persist(new BoolElement(yystack_[0].value.as< bool > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("always-send", persist);
}
#line 2035 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 312:
#line 1158 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr l(new ListElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("pools", l);
    ctx.stack_.push_back(l);
    ctx.enter(ctx.POOLS);
}
#line 2046 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 313:
#line 1163 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 2055 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 318:
#line 1178 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->add(m);
    ctx.stack_.push_back(m);
}
#line 2065 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 319:
#line 1182 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
}
#line 2073 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 320:
#line 1186 "dhcp6_parser.yy" // lalr1.cc:859
    {
    // Parse the pool list entry map
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.push_back(m);
}
#line 2083 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 321:
#line 1190 "dhcp6_parser.yy" // lalr1.cc:859
    {
    // parsing completed
}
#line 2091 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 328:
#line 1204 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2099 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 329:
#line 1206 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr pool(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("pool", pool);
    ctx.leave();
}
#line 2109 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 330:
#line 1212 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2117 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 331:
#line 1214 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.back()->set("user-context", yystack_[0].value.as< ElementPtr > ());
    ctx.leave();
}
#line 2126 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 332:
#line 1222 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr l(new ListElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("pd-pools", l);
    ctx.stack_.push_back(l);
    ctx.enter(ctx.PD_POOLS);
}
#line 2137 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 333:
#line 1227 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 2146 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 338:
#line 1242 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->add(m);
    ctx.stack_.push_back(m);
}
#line 2156 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 339:
#line 1246 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
}
#line 2164 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 340:
#line 1250 "dhcp6_parser.yy" // lalr1.cc:859
    {
    // Parse the pd-pool list entry map
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.push_back(m);
}
#line 2174 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 341:
#line 1254 "dhcp6_parser.yy" // lalr1.cc:859
    {
    // parsing completed
}
#line 2182 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 352:
#line 1272 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2190 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 353:
#line 1274 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr prf(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("prefix", prf);
    ctx.leave();
}
#line 2200 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 354:
#line 1280 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr prf(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("prefix-len", prf);
}
#line 2209 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 355:
#line 1285 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2217 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 356:
#line 1287 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr prf(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("excluded-prefix", prf);
    ctx.leave();
}
#line 2227 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 357:
#line 1293 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr prf(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("excluded-prefix-len", prf);
}
#line 2236 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 358:
#line 1298 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr deleg(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("delegated-len", deleg);
}
#line 2245 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 359:
#line 1306 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr l(new ListElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("reservations", l);
    ctx.stack_.push_back(l);
    ctx.enter(ctx.RESERVATIONS);
}
#line 2256 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 360:
#line 1311 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 2265 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 365:
#line 1324 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->add(m);
    ctx.stack_.push_back(m);
}
#line 2275 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 366:
#line 1328 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
}
#line 2283 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 367:
#line 1332 "dhcp6_parser.yy" // lalr1.cc:859
    {
    // Parse the reservations list entry map
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.push_back(m);
}
#line 2293 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 368:
#line 1336 "dhcp6_parser.yy" // lalr1.cc:859
    {
    // parsing completed
}
#line 2301 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 382:
#line 1360 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr l(new ListElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("ip-addresses", l);
    ctx.stack_.push_back(l);
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2312 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 383:
#line 1365 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 2321 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 384:
#line 1370 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr l(new ListElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("prefixes", l);
    ctx.stack_.push_back(l);
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2332 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 385:
#line 1375 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 2341 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 386:
#line 1380 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2349 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 387:
#line 1382 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr d(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("duid", d);
    ctx.leave();
}
#line 2359 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 388:
#line 1388 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2367 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 389:
#line 1390 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr hw(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("hw-address", hw);
    ctx.leave();
}
#line 2377 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 390:
#line 1396 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2385 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 391:
#line 1398 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr host(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("hostname", host);
    ctx.leave();
}
#line 2395 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 392:
#line 1404 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2403 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 393:
#line 1406 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr hw(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("flex-id", hw);
    ctx.leave();
}
#line 2413 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 394:
#line 1412 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr c(new ListElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("client-classes", c);
    ctx.stack_.push_back(c);
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2424 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 395:
#line 1417 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 2433 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 396:
#line 1425 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("relay", m);
    ctx.stack_.push_back(m);
    ctx.enter(ctx.RELAY);
}
#line 2444 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 397:
#line 1430 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 2453 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 398:
#line 1435 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2461 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 399:
#line 1437 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr ip(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("ip-address", ip);
    ctx.leave();
}
#line 2471 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 400:
#line 1446 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr l(new ListElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("client-classes", l);
    ctx.stack_.push_back(l);
    ctx.enter(ctx.CLIENT_CLASSES);
}
#line 2482 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 401:
#line 1451 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 2491 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 404:
#line 1460 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->add(m);
    ctx.stack_.push_back(m);
}
#line 2501 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 405:
#line 1464 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
}
#line 2509 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 415:
#line 1484 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2517 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 416:
#line 1486 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr test(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("test", test);
    ctx.leave();
}
#line 2527 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 417:
#line 1495 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("server-id", m);
    ctx.stack_.push_back(m);
    ctx.enter(ctx.SERVER_ID);
}
#line 2538 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 418:
#line 1500 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 2547 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 428:
#line 1518 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.DUID_TYPE);
}
#line 2555 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 429:
#line 1520 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.back()->set("type", yystack_[0].value.as< ElementPtr > ());
    ctx.leave();
}
#line 2564 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 430:
#line 1525 "dhcp6_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ElementPtr(new StringElement("LLT", ctx.loc2pos(yystack_[0].location))); }
#line 2570 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 431:
#line 1526 "dhcp6_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ElementPtr(new StringElement("EN", ctx.loc2pos(yystack_[0].location))); }
#line 2576 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 432:
#line 1527 "dhcp6_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ElementPtr(new StringElement("LL", ctx.loc2pos(yystack_[0].location))); }
#line 2582 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 433:
#line 1530 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr htype(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("htype", htype);
}
#line 2591 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 434:
#line 1535 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2599 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 435:
#line 1537 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr id(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("identifier", id);
    ctx.leave();
}
#line 2609 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 436:
#line 1543 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr time(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("time", time);
}
#line 2618 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 437:
#line 1548 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr time(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("enterprise-id", time);
}
#line 2627 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 438:
#line 1555 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr time(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("dhcp4o6-port", time);
}
#line 2636 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 439:
#line 1562 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("control-socket", m);
    ctx.stack_.push_back(m);
    ctx.enter(ctx.CONTROL_SOCKET);
}
#line 2647 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 440:
#line 1567 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 2656 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 445:
#line 1580 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2664 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 446:
#line 1582 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr stype(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("socket-type", stype);
    ctx.leave();
}
#line 2674 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 447:
#line 1588 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2682 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 448:
#line 1590 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr name(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("socket-name", name);
    ctx.leave();
}
#line 2692 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 449:
#line 1598 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("dhcp-ddns", m);
    ctx.stack_.push_back(m);
    ctx.enter(ctx.DHCP_DDNS);
}
#line 2703 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 450:
#line 1603 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 2712 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 451:
#line 1608 "dhcp6_parser.yy" // lalr1.cc:859
    {
    // Parse the dhcp-ddns map
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.push_back(m);
}
#line 2722 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 452:
#line 1612 "dhcp6_parser.yy" // lalr1.cc:859
    {
    // parsing completed
}
#line 2730 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 470:
#line 1637 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr b(new BoolElement(yystack_[0].value.as< bool > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("enable-updates", b);
}
#line 2739 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 471:
#line 1642 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2747 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 472:
#line 1644 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr s(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("qualifying-suffix", s);
    ctx.leave();
}
#line 2757 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 473:
#line 1650 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2765 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 474:
#line 1652 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr s(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("server-ip", s);
    ctx.leave();
}
#line 2775 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 475:
#line 1658 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr i(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("server-port", i);
}
#line 2784 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 476:
#line 1663 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2792 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 477:
#line 1665 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr s(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("sender-ip", s);
    ctx.leave();
}
#line 2802 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 478:
#line 1671 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr i(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("sender-port", i);
}
#line 2811 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 479:
#line 1676 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr i(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("max-queue-size", i);
}
#line 2820 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 480:
#line 1681 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NCR_PROTOCOL);
}
#line 2828 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 481:
#line 1683 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.back()->set("ncr-protocol", yystack_[0].value.as< ElementPtr > ());
    ctx.leave();
}
#line 2837 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 482:
#line 1689 "dhcp6_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ElementPtr(new StringElement("UDP", ctx.loc2pos(yystack_[0].location))); }
#line 2843 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 483:
#line 1690 "dhcp6_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ElementPtr(new StringElement("TCP", ctx.loc2pos(yystack_[0].location))); }
#line 2849 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 484:
#line 1693 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NCR_FORMAT);
}
#line 2857 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 485:
#line 1695 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr json(new StringElement("JSON", ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("ncr-format", json);
    ctx.leave();
}
#line 2867 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 486:
#line 1701 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr b(new BoolElement(yystack_[0].value.as< bool > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("always-include-fqdn", b);
}
#line 2876 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 487:
#line 1706 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr b(new BoolElement(yystack_[0].value.as< bool > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("override-no-update", b);
}
#line 2885 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 488:
#line 1711 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr b(new BoolElement(yystack_[0].value.as< bool > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("override-client-update", b);
}
#line 2894 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 489:
#line 1716 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.REPLACE_CLIENT_NAME);
}
#line 2902 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 490:
#line 1718 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.back()->set("replace-client-name", yystack_[0].value.as< ElementPtr > ());
    ctx.leave();
}
#line 2911 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 491:
#line 1724 "dhcp6_parser.yy" // lalr1.cc:859
    {
      yylhs.value.as< ElementPtr > () = ElementPtr(new StringElement("when-present", ctx.loc2pos(yystack_[0].location))); 
      }
#line 2919 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 492:
#line 1727 "dhcp6_parser.yy" // lalr1.cc:859
    {
      yylhs.value.as< ElementPtr > () = ElementPtr(new StringElement("never", ctx.loc2pos(yystack_[0].location)));
      }
#line 2927 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 493:
#line 1730 "dhcp6_parser.yy" // lalr1.cc:859
    {
      yylhs.value.as< ElementPtr > () = ElementPtr(new StringElement("always", ctx.loc2pos(yystack_[0].location)));
      }
#line 2935 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 494:
#line 1733 "dhcp6_parser.yy" // lalr1.cc:859
    {
      yylhs.value.as< ElementPtr > () = ElementPtr(new StringElement("when-not-present", ctx.loc2pos(yystack_[0].location)));
      }
#line 2943 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 495:
#line 1736 "dhcp6_parser.yy" // lalr1.cc:859
    {
      error(yystack_[0].location, "boolean values for the replace-client-name are "
                "no longer supported");
      }
#line 2952 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 496:
#line 1742 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2960 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 497:
#line 1744 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr s(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("generated-prefix", s);
    ctx.leave();
}
#line 2970 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 498:
#line 1752 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2978 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 499:
#line 1754 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.back()->set("Dhcp4", yystack_[0].value.as< ElementPtr > ());
    ctx.leave();
}
#line 2987 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 500:
#line 1759 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2995 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 501:
#line 1761 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.back()->set("DhcpDdns", yystack_[0].value.as< ElementPtr > ());
    ctx.leave();
}
#line 3004 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 502:
#line 1766 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 3012 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 503:
#line 1768 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.back()->set("Control-agent", yystack_[0].value.as< ElementPtr > ());
    ctx.leave();
}
#line 3021 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 504:
#line 1779 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("Logging", m);
    ctx.stack_.push_back(m);
    ctx.enter(ctx.LOGGING);
}
#line 3032 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 505:
#line 1784 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 3041 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 509:
#line 1801 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr l(new ListElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("loggers", l);
    ctx.stack_.push_back(l);
    ctx.enter(ctx.LOGGERS);
}
#line 3052 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 510:
#line 1806 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 3061 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 513:
#line 1818 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr l(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->add(l);
    ctx.stack_.push_back(l);
}
#line 3071 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 514:
#line 1822 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
}
#line 3079 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 522:
#line 1837 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr dl(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("debuglevel", dl);
}
#line 3088 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 523:
#line 1842 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 3096 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 524:
#line 1844 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr sev(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("severity", sev);
    ctx.leave();
}
#line 3106 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 525:
#line 1850 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr l(new ListElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("output_options", l);
    ctx.stack_.push_back(l);
    ctx.enter(ctx.OUTPUT_OPTIONS);
}
#line 3117 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 526:
#line 1855 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 3126 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 529:
#line 1864 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->add(m);
    ctx.stack_.push_back(m);
}
#line 3136 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 530:
#line 1868 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
}
#line 3144 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 537:
#line 1882 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 3152 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 538:
#line 1884 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr sev(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("output", sev);
    ctx.leave();
}
#line 3162 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 539:
#line 1890 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr flush(new BoolElement(yystack_[0].value.as< bool > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("flush", flush);
}
#line 3171 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 540:
#line 1895 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr maxsize(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("maxsize", maxsize);
}
#line 3180 "dhcp6_parser.cc" // lalr1.cc:859
    break;

  case 541:
#line 1900 "dhcp6_parser.yy" // lalr1.cc:859
    {
    ElementPtr maxver(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("maxver", maxver);
}
#line 3189 "dhcp6_parser.cc" // lalr1.cc:859
    break;


#line 3193 "dhcp6_parser.cc" // lalr1.cc:859
            default:
              break;
            }
        }
      catch (const syntax_error& yyexc)
        {
          error (yyexc);
          YYERROR;
        }
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;
      YY_STACK_PRINT ();

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, yylhs);
    }
    goto yynewstate;

  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        error (yyla.location, yysyntax_error_ (yystack_[0].state, yyla));
      }


    yyerror_range[1].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.type_get () == yyeof_)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:

    /* Pacify compilers like GCC when the user code never invokes
       YYERROR and the label yyerrorlab therefore never appears in user
       code.  */
    if (false)
      goto yyerrorlab;
    yyerror_range[1].location = yystack_[yylen - 1].location;
    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    goto yyerrlab1;

  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    {
      stack_symbol_type error_token;
      for (;;)
        {
          yyn = yypact_[yystack_[0].state];
          if (!yy_pact_value_is_default_ (yyn))
            {
              yyn += yyterror_;
              if (0 <= yyn && yyn <= yylast_ && yycheck_[yyn] == yyterror_)
                {
                  yyn = yytable_[yyn];
                  if (0 < yyn)
                    break;
                }
            }

          // Pop the current state because it cannot handle the error token.
          if (yystack_.size () == 1)
            YYABORT;

          yyerror_range[1].location = yystack_[0].location;
          yy_destroy_ ("Error: popping", yystack_[0]);
          yypop_ ();
          YY_STACK_PRINT ();
        }

      yyerror_range[2].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, yyerror_range, 2);

      // Shift the error token.
      error_token.state = yyn;
      yypush_ ("Shifting", error_token);
    }
    goto yynewstate;

    // Accept.
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;

    // Abort.
  yyabortlab:
    yyresult = 1;
    goto yyreturn;

  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack"
                 << std::endl;
        // Do not try to display the values of the reclaimed symbols,
        // as their printer might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
  }

  void
  Dhcp6Parser::error (const syntax_error& yyexc)
  {
    error (yyexc.location, yyexc.what());
  }

  // Generate an error message.
  std::string
  Dhcp6Parser::yysyntax_error_ (state_type yystate, const symbol_type& yyla) const
  {
    // Number of reported tokens (one for the "unexpected", one per
    // "expected").
    size_t yycount = 0;
    // Its maximum.
    enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
    // Arguments of yyformat.
    char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];

    /* There are many possibilities here to consider:
       - If this state is a consistent state with a default action, then
         the only way this function was invoked is if the default action
         is an error action.  In that case, don't check for expected
         tokens because there are none.
       - The only way there can be no lookahead present (in yyla) is
         if this state is a consistent state with a default action.
         Thus, detecting the absence of a lookahead is sufficient to
         determine that there is no unexpected or expected token to
         report.  In that case, just report a simple "syntax error".
       - Don't assume there isn't a lookahead just because this state is
         a consistent state with a default action.  There might have
         been a previous inconsistent state, consistent state with a
         non-default action, or user semantic action that manipulated
         yyla.  (However, yyla is currently not documented for users.)
       - Of course, the expected token list depends on states to have
         correct lookahead information, and it depends on the parser not
         to perform extra reductions after fetching a lookahead from the
         scanner and before detecting a syntax error.  Thus, state
         merging (from LALR or IELR) and default reductions corrupt the
         expected token list.  However, the list is correct for
         canonical LR with one exception: it will still contain any
         token that will not be accepted due to an error action in a
         later state.
    */
    if (!yyla.empty ())
      {
        int yytoken = yyla.type_get ();
        yyarg[yycount++] = yytname_[yytoken];
        int yyn = yypact_[yystate];
        if (!yy_pact_value_is_default_ (yyn))
          {
            /* Start YYX at -YYN if negative to avoid negative indexes in
               YYCHECK.  In other words, skip the first -YYN actions for
               this state because they are default actions.  */
            int yyxbegin = yyn < 0 ? -yyn : 0;
            // Stay within bounds of both yycheck and yytname.
            int yychecklim = yylast_ - yyn + 1;
            int yyxend = yychecklim < yyntokens_ ? yychecklim : yyntokens_;
            for (int yyx = yyxbegin; yyx < yyxend; ++yyx)
              if (yycheck_[yyx + yyn] == yyx && yyx != yyterror_
                  && !yy_table_value_is_error_ (yytable_[yyx + yyn]))
                {
                  if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                    {
                      yycount = 1;
                      break;
                    }
                  else
                    yyarg[yycount++] = yytname_[yyx];
                }
          }
      }

    char const* yyformat = YY_NULLPTR;
    switch (yycount)
      {
#define YYCASE_(N, S)                         \
        case N:                               \
          yyformat = S;                       \
        break
        YYCASE_(0, YY_("syntax error"));
        YYCASE_(1, YY_("syntax error, unexpected %s"));
        YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
        YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
        YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
        YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
      }

    std::string yyres;
    // Argument number.
    size_t yyi = 0;
    for (char const* yyp = yyformat; *yyp; ++yyp)
      if (yyp[0] == '%' && yyp[1] == 's' && yyi < yycount)
        {
          yyres += yytnamerr_ (yyarg[yyi++]);
          ++yyp;
        }
      else
        yyres += *yyp;
    return yyres;
  }


  const short int Dhcp6Parser::yypact_ninf_ = -507;

  const signed char Dhcp6Parser::yytable_ninf_ = -1;

  const short int
  Dhcp6Parser::yypact_[] =
  {
      61,  -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,
    -507,  -507,  -507,    33,    19,    24,    46,    64,    84,   123,
     140,   144,   148,   169,   182,   184,  -507,  -507,  -507,  -507,
    -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,
    -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,
    -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,
      19,   -77,    17,    31,   226,    23,    40,    -5,   109,    62,
      -4,    -8,   137,  -507,    87,   119,   162,   203,   224,  -507,
    -507,  -507,  -507,  -507,   284,  -507,   104,  -507,  -507,  -507,
    -507,  -507,  -507,  -507,  -507,  -507,   294,   307,   309,   310,
     311,  -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,
    -507,   314,  -507,  -507,  -507,   112,  -507,  -507,  -507,  -507,
    -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,
    -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,   315,
     125,  -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,
     324,   325,  -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,
    -507,   126,  -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,
    -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,   133,
    -507,  -507,  -507,  -507,   326,  -507,   327,   328,  -507,  -507,
    -507,   141,  -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,
    -507,  -507,  -507,  -507,  -507,  -507,  -507,   228,   330,  -507,
    -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,   331,
    -507,  -507,  -507,   333,  -507,  -507,   302,   335,  -507,  -507,
    -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,   336,
     337,  -507,  -507,  -507,  -507,   334,   340,  -507,  -507,  -507,
    -507,  -507,  -507,  -507,  -507,  -507,  -507,   172,  -507,  -507,
    -507,   341,  -507,  -507,   342,  -507,   343,   344,  -507,  -507,
     345,   346,   347,  -507,  -507,  -507,   174,  -507,  -507,  -507,
    -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,
    -507,  -507,  -507,    19,    19,  -507,   189,   348,   349,   350,
     351,   352,  -507,    17,  -507,   353,   354,   355,   183,   209,
     210,   211,   212,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   225,   370,   371,    31,  -507,   373,   191,
     226,  -507,    48,   374,   375,   376,   377,   378,   233,   230,
     381,   382,   383,   384,    23,  -507,   385,   386,    40,  -507,
     387,   241,   389,   243,   244,    -5,  -507,   392,   393,   394,
     395,   396,   397,   398,  -507,   109,   399,   400,   256,   401,
     402,   404,   258,  -507,    62,   405,   259,   260,  -507,    -4,
     406,   410,   193,  -507,   262,   415,   416,   270,   418,   273,
     274,   419,   422,   275,   276,   277,   423,   427,   137,  -507,
    -507,  -507,   428,   426,   429,    19,    19,    19,  -507,   430,
     431,   432,  -507,  -507,  -507,  -507,  -507,   435,   436,   437,
     438,   439,   440,   441,   444,   443,   446,  -507,   447,   448,
    -507,   451,  -507,  -507,  -507,  -507,  -507,  -507,   449,   456,
    -507,  -507,  -507,   457,   458,   285,   316,   317,  -507,  -507,
     149,   318,   459,   454,  -507,   320,   464,  -507,   322,  -507,
     323,  -507,  -507,  -507,   451,   451,   451,   329,   332,   338,
     339,  -507,   356,   357,  -507,   358,   359,   372,  -507,  -507,
     379,  -507,  -507,  -507,   380,    19,  -507,  -507,   388,   390,
    -507,   391,  -507,  -507,   159,   313,  -507,  -507,  -507,    15,
     403,  -507,    19,    31,   407,  -507,  -507,  -507,   226,   134,
     134,   467,   468,   469,   -33,    19,   116,    22,   470,   131,
      28,   206,   137,  -507,  -507,   476,  -507,    48,   474,   477,
    -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,   478,   409,
    -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,
    -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,
    -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,
    -507,  -507,  -507,  -507,  -507,   223,  -507,   232,  -507,  -507,
     253,  -507,  -507,  -507,  -507,   479,   482,   483,   487,   488,
    -507,  -507,  -507,   254,  -507,  -507,  -507,  -507,  -507,  -507,
    -507,  -507,  -507,  -507,  -507,  -507,  -507,   255,  -507,   489,
     490,  -507,  -507,   491,   495,  -507,  -507,   493,   497,  -507,
    -507,  -507,    29,  -507,  -507,  -507,   496,  -507,  -507,  -507,
      74,  -507,  -507,  -507,  -507,    86,  -507,   498,   500,  -507,
     501,   506,   507,   508,   510,   511,   257,  -507,  -507,  -507,
    -507,  -507,  -507,  -507,  -507,  -507,   512,   513,   514,  -507,
    -507,   261,  -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,
     263,  -507,  -507,  -507,   264,   408,   411,  -507,  -507,   515,
     516,  -507,  -507,   517,   521,  -507,  -507,   519,   523,  -507,
    -507,   486,  -507,   524,   407,  -507,  -507,   527,   528,   529,
     531,   412,   413,   414,   417,   420,   532,   533,   134,  -507,
    -507,    23,  -507,   467,    62,  -507,   468,    -4,  -507,   469,
     -33,  -507,  -507,   116,  -507,    22,  -507,    -8,  -507,   470,
     421,   424,   425,   433,   434,   442,   131,  -507,   535,   538,
     445,   450,   452,    28,  -507,   539,   540,   206,  -507,  -507,
    -507,   541,   542,  -507,    40,  -507,   474,    -5,  -507,   477,
     109,  -507,   478,   544,  -507,   522,  -507,   306,   455,   460,
     461,  -507,  -507,  -507,  -507,  -507,   462,   463,  -507,   265,
    -507,   543,  -507,   546,  -507,  -507,  -507,  -507,   272,  -507,
    -507,  -507,  -507,  -507,  -507,  -507,  -507,   -34,   465,  -507,
    -507,  -507,  -507,   466,   471,  -507,  -507,   472,   282,  -507,
     288,  -507,   547,  -507,   473,   494,  -507,  -507,  -507,  -507,
    -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,
    -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,
    -507,  -507,  -507,  -507,   108,  -507,    66,   494,  -507,  -507,
     545,  -507,  -507,  -507,   289,  -507,  -507,  -507,  -507,  -507,
     548,   453,   552,    66,  -507,   554,  -507,   475,  -507,   550,
    -507,  -507,   115,  -507,   100,   550,  -507,  -507,   556,   558,
     560,   299,  -507,  -507,  -507,  -507,  -507,  -507,   563,   480,
     481,   484,   100,  -507,   492,  -507,  -507,  -507,  -507,  -507
  };

  const unsigned short int
  Dhcp6Parser::yydefact_[] =
  {
       0,     2,     4,     6,     8,    10,    12,    14,    16,    18,
      20,    22,    24,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     1,    41,    34,    30,
      29,    26,    27,    28,    33,     3,    31,    32,    54,     5,
      66,     7,    99,     9,   213,    11,   320,    13,   340,    15,
     367,    17,   257,    19,   292,    21,   178,    23,   451,    25,
      43,    37,     0,     0,     0,     0,     0,     0,   369,   259,
     294,     0,     0,    45,     0,    44,     0,     0,    38,    64,
     504,   498,   500,   502,     0,    63,     0,    56,    58,    60,
      61,    62,    59,    97,   108,   110,     0,     0,     0,     0,
       0,   205,   249,   284,   151,   168,   159,   400,   170,   189,
     417,     0,   439,   449,    91,     0,    68,    70,    71,    72,
      73,    74,    76,    77,    78,    79,    81,    80,    85,    86,
      75,    83,    84,    82,    87,    88,    89,    90,   105,     0,
       0,   101,   103,   104,   404,   312,   332,   234,   236,   238,
       0,     0,   242,   240,   359,   396,   233,   217,   218,   219,
     220,     0,   215,   224,   225,   226,   229,   231,   227,   228,
     221,   222,   223,   230,   232,   328,   330,   327,   325,     0,
     322,   324,   326,   352,     0,   355,     0,     0,   351,   347,
     350,     0,   342,   344,   345,   348,   349,   346,   394,   382,
     384,   386,   388,   390,   392,   381,   380,     0,   370,   371,
     375,   376,   373,   377,   378,   379,   374,   274,   141,     0,
     278,   276,   281,     0,   270,   271,     0,   260,   261,   263,
     273,   264,   265,   266,   280,   267,   268,   269,   306,     0,
       0,   304,   305,   308,   309,     0,   295,   296,   298,   299,
     300,   301,   302,   303,   185,   187,   182,     0,   180,   183,
     184,     0,   471,   473,     0,   476,     0,     0,   480,   484,
       0,     0,     0,   489,   496,   469,     0,   453,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,    42,     0,     0,    35,     0,     0,     0,     0,
       0,     0,    53,     0,    55,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    67,     0,     0,
       0,   100,   406,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   214,     0,     0,     0,   321,
       0,     0,     0,     0,     0,     0,   341,     0,     0,     0,
       0,     0,     0,     0,   368,     0,     0,     0,     0,     0,
       0,     0,     0,   258,     0,     0,     0,     0,   293,     0,
       0,     0,     0,   179,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   452,
      46,    39,     0,     0,     0,     0,     0,     0,    57,     0,
       0,     0,    92,    93,    94,    95,    96,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   438,     0,     0,
      69,     0,   107,   102,   415,   413,   414,   412,     0,   407,
     408,   410,   411,     0,     0,     0,     0,     0,   247,   248,
       0,     0,     0,     0,   216,     0,     0,   323,     0,   354,
       0,   357,   358,   343,     0,     0,     0,     0,     0,     0,
       0,   372,     0,     0,   272,     0,     0,     0,   283,   262,
       0,   310,   311,   297,     0,     0,   181,   470,     0,     0,
     475,     0,   478,   479,     0,     0,   486,   487,   488,     0,
       0,   454,     0,     0,     0,   499,   501,   503,     0,     0,
       0,   207,   251,   286,     0,    43,     0,     0,   172,     0,
       0,     0,     0,    47,   106,     0,   405,     0,   314,   334,
     235,   237,   239,   244,   245,   246,   243,   241,   361,     0,
     329,    36,   331,   353,   356,   395,   383,   385,   387,   389,
     391,   393,   275,   142,   279,   277,   282,   307,   186,   188,
     472,   474,   477,   482,   483,   481,   485,   491,   492,   493,
     494,   495,   490,   497,    40,     0,   509,     0,   506,   508,
       0,   127,   134,   136,   138,     0,     0,     0,     0,     0,
     147,   149,   126,     0,   112,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,     0,   211,     0,
     208,   209,   255,     0,   252,   253,   290,     0,   287,   288,
     157,   158,     0,   153,   155,   156,     0,   166,   167,   163,
       0,   161,   164,   165,   402,     0,   176,     0,   173,   174,
       0,     0,     0,     0,     0,     0,     0,   191,   193,   194,
     195,   196,   197,   198,   428,   434,     0,     0,     0,   427,
     426,     0,   419,   421,   424,   422,   423,   425,   445,   447,
       0,   441,   443,   444,     0,    49,     0,   409,   318,     0,
     315,   316,   338,     0,   335,   336,   365,     0,   362,   363,
     398,     0,    65,     0,     0,   505,    98,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   109,
     111,     0,   206,     0,   259,   250,     0,   294,   285,     0,
       0,   152,   169,     0,   160,     0,   401,     0,   171,     0,
       0,     0,     0,     0,     0,     0,     0,   190,     0,     0,
       0,     0,     0,     0,   418,     0,     0,     0,   440,   450,
      51,     0,    50,   416,     0,   313,     0,     0,   333,     0,
     369,   360,     0,     0,   397,     0,   507,     0,     0,     0,
       0,   140,   143,   144,   145,   146,     0,     0,   113,     0,
     210,     0,   254,     0,   289,   154,   162,   403,     0,   175,
     199,   200,   201,   202,   203,   204,   192,     0,     0,   433,
     436,   437,   420,     0,     0,   442,    48,     0,     0,   317,
       0,   337,     0,   364,     0,     0,   129,   130,   131,   132,
     133,   128,   135,   137,   139,   148,   150,   212,   256,   291,
     177,   430,   431,   432,   429,   435,   446,   448,    52,   319,
     339,   366,   399,   513,     0,   511,     0,     0,   510,   525,
       0,   523,   521,   517,     0,   515,   519,   520,   518,   512,
       0,     0,     0,     0,   514,     0,   522,     0,   516,     0,
     524,   529,     0,   527,     0,     0,   526,   537,     0,     0,
       0,     0,   531,   533,   534,   535,   536,   528,     0,     0,
       0,     0,     0,   530,     0,   539,   540,   541,   532,   538
  };

  const short int
  Dhcp6Parser::yypgoto_[] =
  {
    -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,
    -507,  -507,  -507,  -507,    11,  -507,    90,  -507,  -507,  -507,
    -507,  -507,  -507,     5,  -507,  -241,  -507,  -507,  -507,   -62,
    -507,  -507,  -507,   247,  -507,  -507,  -507,  -507,    65,   248,
     -63,   -50,   -44,   -43,  -507,  -507,  -507,  -507,  -507,    69,
     239,  -507,  -507,  -507,  -507,  -507,  -507,  -507,    63,  -130,
    -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,
     -58,  -507,  -506,  -507,  -507,  -507,  -507,  -507,  -507,  -507,
    -507,  -507,  -507,  -141,  -493,  -507,  -507,  -507,  -507,  -143,
    -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,  -148,  -507,
    -507,  -507,  -145,   201,  -507,  -507,  -507,  -507,  -507,  -507,
    -507,  -150,  -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,
    -507,  -507,  -126,  -507,  -507,  -507,  -123,   245,  -507,  -507,
    -507,  -507,  -507,  -507,  -497,  -507,  -507,  -507,  -507,  -507,
    -507,  -507,  -507,  -507,  -507,  -125,  -507,  -507,  -507,  -124,
    -507,   218,  -507,   -59,  -507,  -507,  -507,  -507,  -507,   -57,
    -507,  -507,  -507,  -507,  -507,   -49,  -507,  -507,  -507,  -122,
    -507,  -507,  -507,  -119,  -507,   215,  -507,  -507,  -507,  -507,
    -507,  -507,  -507,  -507,  -507,  -507,  -507,  -161,  -507,  -507,
    -507,  -155,   252,  -507,  -507,   -66,  -507,  -507,  -507,  -507,
    -507,  -157,  -507,  -507,  -507,  -151,   269,  -507,  -507,  -507,
    -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,  -154,  -507,
    -507,  -507,  -153,  -507,   249,  -507,  -507,  -507,  -507,  -507,
    -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,
    -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,    82,
    -507,  -507,  -507,  -507,  -507,  -507,  -117,  -507,  -507,  -507,
    -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,  -129,
    -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,    95,   221,
    -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,
    -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,
    -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,  -507,
    -507,  -507,   -74,  -507,  -507,  -507,  -220,  -507,  -507,  -235,
    -507,  -507,  -507,  -507,  -507,  -507,  -246,  -507,  -507,  -262,
    -507,  -507,  -507,  -507,  -507
  };

  const short int
  Dhcp6Parser::yydefgoto_[] =
  {
      -1,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    73,    35,    36,    61,   542,    77,
      78,    37,    60,    74,    75,   524,   675,   751,   752,   114,
      39,    62,    86,    87,    88,   297,    41,    63,   115,   116,
     117,   118,   119,   120,   121,   122,   305,    43,    64,   140,
     141,   142,   328,   143,   123,   306,   124,   307,   593,   594,
     595,   697,   821,   596,   698,   597,   699,   598,   700,   599,
     225,   367,   601,   602,   603,   604,   605,   706,   606,   707,
     125,   316,   622,   623,   624,   625,   126,   318,   630,   631,
     632,   633,   127,   317,   128,   320,   637,   638,   639,   727,
      57,    71,   257,   258,   259,   380,   260,   381,   129,   321,
     646,   647,   648,   649,   650,   651,   652,   653,   130,   313,
     609,   610,   611,   711,    45,    65,   161,   162,   163,   335,
     164,   336,   165,   337,   166,   341,   167,   340,   536,   168,
     169,   131,   314,   613,   614,   615,   714,    53,    69,   226,
     227,   228,   229,   230,   231,   232,   366,   233,   370,   234,
     369,   235,   236,   371,   237,   132,   315,   617,   618,   619,
     717,    55,    70,   245,   246,   247,   248,   249,   375,   250,
     251,   252,   253,   171,   333,   679,   680,   681,   754,    47,
      66,   179,   180,   181,   346,   182,   347,   172,   334,   683,
     684,   685,   757,    49,    67,   191,   192,   193,   350,   194,
     195,   352,   196,   197,   173,   342,   687,   688,   689,   760,
      51,    68,   207,   208,   209,   210,   358,   211,   359,   212,
     360,   213,   361,   214,   362,   215,   363,   216,   357,   174,
     343,   691,   763,   133,   319,   635,   332,   438,   439,   440,
     441,   442,   525,   134,   322,   661,   662,   663,   738,   834,
     664,   665,   739,   666,   667,   135,   136,   324,   670,   671,
     672,   745,   673,   746,   137,   325,    59,    72,   276,   277,
     278,   279,   385,   280,   386,   281,   282,   388,   283,   284,
     285,   391,   565,   286,   392,   287,   288,   289,   290,   396,
     572,   291,   397,    89,   299,    90,   300,    91,   301,    92,
     298,   577,   578,   579,   693,   844,   845,   846,   854,   855,
     856,   857,   862,   858,   860,   872,   873,   874,   881,   882,
     883,   888,   884,   885,   886
  };

  const unsigned short int
  Dhcp6Parser::yytable_[] =
  {
      85,   190,   157,   156,   177,   188,   205,   224,   241,   256,
     275,   243,   242,   244,   660,   158,   170,   178,   189,   206,
     634,   159,   160,   629,    27,    34,    28,    79,    29,   144,
     144,    38,   720,    26,   103,   721,   218,   238,   219,   220,
     239,   240,    93,   620,   654,    94,    95,   183,   184,   185,
     186,   187,   176,    40,   586,    96,    97,    98,    99,   831,
     832,   833,   103,    96,    97,    98,    99,   100,   101,   102,
     103,    42,   145,    76,   146,   254,   255,   723,   217,   103,
     724,   147,   148,   149,   150,   151,   152,   103,   218,   725,
     175,    44,   726,   292,   153,   153,   154,   176,   104,   105,
     106,   107,   218,   155,   219,   220,   218,   303,   221,   222,
     223,   847,   304,   108,   848,   326,   109,   621,   875,   434,
     327,   876,   293,   110,   655,   656,   657,   658,   330,   344,
      46,   111,   112,   331,   345,   113,   348,   567,   568,   569,
     570,   349,    84,    80,   355,    84,    84,    48,   103,   356,
     581,    50,    81,    82,    83,    52,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   294,    84,   571,    30,
      31,    32,    33,    84,   218,   382,    54,   398,    84,   198,
     383,    84,   399,   199,   200,   201,   202,   203,   204,    56,
      84,    58,   620,   627,   849,   628,   850,   851,    84,     1,
       2,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,   295,    84,   533,   534,   535,    84,   640,   641,   642,
     643,   644,   645,   545,   546,   547,   326,   296,   787,   877,
     629,   692,   878,   879,   880,   694,   364,   660,   138,   139,
     695,    85,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   330,   708,   708,    84,
     736,   696,   709,   710,   743,   737,   747,   398,   344,   744,
     435,   748,   749,   827,   436,   382,   254,   255,   563,   564,
     830,   157,   156,   437,    84,   348,   177,    84,   302,   190,
     839,   355,   863,   188,   158,   170,   840,   864,   308,   178,
     159,   160,   892,   205,   400,   401,   189,   893,   668,   669,
     373,   309,   224,   310,   311,   312,   206,   241,   323,   329,
     243,   242,   244,   816,   817,   818,   819,   820,   338,   339,
     351,   353,   354,   365,   412,   368,   275,   372,   374,   402,
     376,   377,   378,   379,   432,   384,   387,   389,   390,   393,
     394,   395,   403,   404,   405,   406,   407,   409,   410,   411,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   428,   429,   427,   431,   443,   444,
     445,   446,   447,   449,   448,   450,   451,   452,   453,   455,
     456,   458,   459,   460,   461,   462,   464,   465,   466,   467,
     468,   469,   470,   472,   473,   475,   476,   474,   477,   480,
     484,   478,   481,   482,   485,   487,   505,   506,   507,   488,
     489,   490,   491,   494,   492,   493,   495,   499,   496,   497,
     498,   500,   502,   503,   566,   530,   504,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   592,   592,   518,
     519,   600,   600,   520,   521,   522,   523,   526,   659,   527,
     275,   539,   528,   529,   538,   435,   531,   532,   537,   436,
     540,    28,   543,   544,   608,   612,   616,   636,   437,   548,
     676,   678,   549,   701,   682,   686,   702,   703,   550,   551,
     690,   704,   705,   713,   764,   712,   559,   715,   716,   718,
     719,   843,   722,   729,   728,   730,   552,   553,   554,   555,
     731,   732,   733,   574,   734,   735,   740,   741,   742,   756,
     626,   755,   556,   758,   759,   761,   762,   815,   765,   557,
     558,   767,   768,   769,   576,   770,   776,   777,   560,   797,
     561,   562,   798,   803,   804,   807,   541,   806,   814,   861,
     408,   828,   865,   573,   829,   841,   867,   871,   750,   869,
     889,   753,   890,   771,   891,   773,   772,   894,   575,   433,
     774,   775,   790,   607,   430,   791,   792,   580,   778,   785,
     786,   789,   788,   486,   793,   794,   796,   780,   779,   454,
     781,   782,   479,   795,   483,   809,   799,   784,   783,   808,
     457,   800,   811,   801,   866,   822,   810,   812,   813,   677,
     823,   824,   825,   826,   471,   835,   836,   674,   805,   501,
     766,   837,   838,   842,   463,   870,   802,   859,   868,   887,
     898,     0,   896,   895,     0,   897,     0,     0,     0,     0,
       0,     0,   899,     0,     0,     0,   592,     0,   157,   156,
     600,     0,   224,     0,     0,   241,     0,     0,   243,   242,
     244,   158,   170,     0,     0,   256,     0,   159,   160,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   659,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   190,   177,     0,     0,   188,     0,     0,   205,     0,
       0,     0,     0,     0,     0,   178,     0,     0,   189,     0,
       0,   206,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   852,     0,     0,     0,   853,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   852,     0,     0,     0,   853
  };

  const short int
  Dhcp6Parser::yycheck_[] =
  {
      62,    67,    65,    65,    66,    67,    68,    69,    70,    71,
      72,    70,    70,    70,   520,    65,    65,    66,    67,    68,
     517,    65,    65,   516,     5,    14,     7,    10,     9,     7,
       7,     7,     3,     0,    39,     6,    40,    41,    42,    43,
      44,    45,    11,    76,    16,    14,    15,    52,    53,    54,
      55,    56,    57,     7,    26,    32,    33,    34,    35,    93,
      94,    95,    39,    32,    33,    34,    35,    36,    37,    38,
      39,     7,    49,   150,    51,    83,    84,     3,    16,    39,
       6,    58,    59,    60,    61,    62,    63,    39,    40,     3,
      50,     7,     6,     6,    72,    72,    73,    57,    67,    68,
      69,    70,    40,    80,    42,    43,    40,     3,    46,    47,
      48,     3,     8,    82,     6,     3,    85,   150,     3,    71,
       8,     6,     3,    92,    96,    97,    98,    99,     3,     3,
       7,   100,   101,     8,     8,   104,     3,   122,   123,   124,
     125,     8,   150,   126,     3,   150,   150,     7,    39,     8,
      16,     7,   135,   136,   137,     7,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,     4,   150,   153,   150,
     151,   152,   153,   150,    40,     3,     7,     3,   150,    70,
       8,   150,     8,    74,    75,    76,    77,    78,    79,     7,
     150,     7,    76,    77,   128,    79,   130,   131,   150,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,     8,   150,    64,    65,    66,   150,    86,    87,    88,
      89,    90,    91,   464,   465,   466,     3,     3,   725,   129,
     723,     8,   132,   133,   134,     3,     8,   743,    12,    13,
       8,   303,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,     3,     3,     3,   150,
       3,     8,     8,     8,     3,     8,     3,     3,     3,     8,
     332,     8,     8,     8,   332,     3,    83,    84,   119,   120,
       8,   344,   344,   332,   150,     3,   348,   150,     4,   355,
       8,     3,     3,   355,   344,   344,     8,     8,     4,   348,
     344,   344,     3,   365,   293,   294,   355,     8,   102,   103,
       8,     4,   374,     4,     4,     4,   365,   379,     4,     4,
     379,   379,   379,    17,    18,    19,    20,    21,     4,     4,
       4,     4,     4,     3,   151,     4,   398,     4,     3,   150,
       4,     4,     8,     3,   153,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
     151,   151,   151,   151,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,   151,     4,     4,     4,
       4,     4,     4,   153,   151,     4,     4,     4,     4,     4,
       4,     4,   151,     4,   151,   151,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,   151,     4,     4,
       4,   153,   153,   153,     4,   153,   405,   406,   407,     4,
       4,   151,     4,     4,   151,   151,     4,     4,   153,   153,
     153,     4,     4,     7,   121,   150,     7,     7,     7,     7,
       5,     5,     5,     5,     5,     5,     5,   509,   510,     5,
       7,   509,   510,     7,     7,     7,     5,     8,   520,     3,
     522,     7,     5,     5,     5,   527,   150,   150,   150,   527,
     150,     7,   150,   150,     7,     7,     7,     7,   527,   150,
       4,     7,   150,     4,     7,     7,     4,     4,   150,   150,
      81,     4,     4,     3,     8,     6,   485,     6,     3,     6,
       3,     7,     6,     3,     6,     4,   150,   150,   150,   150,
       4,     4,     4,   502,     4,     4,     4,     4,     4,     3,
     515,     6,   150,     6,     3,     6,     3,     5,     4,   150,
     150,     4,     4,     4,   127,     4,     4,     4,   150,     4,
     150,   150,     4,     4,     4,     3,   456,     6,     4,     4,
     303,     8,     4,   150,     8,     8,     4,     7,   150,     5,
       4,   150,     4,   151,     4,   151,   153,     4,   503,   330,
     153,   151,   151,   510,   326,   151,   151,   508,   708,   720,
     723,   729,   727,   382,   151,   151,   736,   713,   711,   344,
     714,   716,   374,   151,   379,   756,   151,   719,   717,   754,
     348,   151,   759,   151,   151,   150,   757,   760,   762,   527,
     150,   150,   150,   150,   365,   150,   150,   522,   747,   398,
     694,   150,   150,   150,   355,   150,   743,   847,   863,   875,
     892,    -1,   151,   153,    -1,   151,    -1,    -1,    -1,    -1,
      -1,    -1,   150,    -1,    -1,    -1,   708,    -1,   711,   711,
     708,    -1,   714,    -1,    -1,   717,    -1,    -1,   717,   717,
     717,   711,   711,    -1,    -1,   727,    -1,   711,   711,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   743,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   757,   754,    -1,    -1,   757,    -1,    -1,   760,    -1,
      -1,    -1,    -1,    -1,    -1,   754,    -1,    -1,   757,    -1,
      -1,   760,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   846,    -1,    -1,    -1,   846,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   863,    -1,    -1,    -1,   863
  };

  const unsigned short int
  Dhcp6Parser::yystos_[] =
  {
       0,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,     0,     5,     7,     9,
     150,   151,   152,   153,   168,   169,   170,   175,     7,   184,
       7,   190,     7,   201,     7,   278,     7,   343,     7,   357,
       7,   374,     7,   301,     7,   325,     7,   254,     7,   430,
     176,   171,   185,   191,   202,   279,   344,   358,   375,   302,
     326,   255,   431,   168,   177,   178,   150,   173,   174,    10,
     126,   135,   136,   137,   150,   183,   186,   187,   188,   457,
     459,   461,   463,    11,    14,    15,    32,    33,    34,    35,
      36,    37,    38,    39,    67,    68,    69,    70,    82,    85,
      92,   100,   101,   104,   183,   192,   193,   194,   195,   196,
     197,   198,   199,   208,   210,   234,   240,   246,   248,   262,
     272,   295,   319,   397,   407,   419,   420,   428,    12,    13,
     203,   204,   205,   207,     7,    49,    51,    58,    59,    60,
      61,    62,    63,    72,    73,    80,   183,   194,   195,   196,
     197,   280,   281,   282,   284,   286,   288,   290,   293,   294,
     319,   337,   351,   368,   393,    50,    57,   183,   319,   345,
     346,   347,   349,    52,    53,    54,    55,    56,   183,   319,
     349,   359,   360,   361,   363,   364,   366,   367,    70,    74,
      75,    76,    77,    78,    79,   183,   319,   376,   377,   378,
     379,   381,   383,   385,   387,   389,   391,    16,    40,    42,
      43,    46,    47,    48,   183,   224,   303,   304,   305,   306,
     307,   308,   309,   311,   313,   315,   316,   318,    41,    44,
      45,   183,   224,   307,   313,   327,   328,   329,   330,   331,
     333,   334,   335,   336,    83,    84,   183,   256,   257,   258,
     260,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   183,   432,   433,   434,   435,
     437,   439,   440,   442,   443,   444,   447,   449,   450,   451,
     452,   455,     6,     3,     4,     8,     3,   189,   464,   458,
     460,   462,     4,     3,     8,   200,   209,   211,     4,     4,
       4,     4,     4,   273,   296,   320,   235,   247,   241,   398,
     249,   263,   408,     4,   421,   429,     3,     8,   206,     4,
       3,     8,   400,   338,   352,   283,   285,   287,     4,     4,
     291,   289,   369,   394,     3,     8,   348,   350,     3,     8,
     362,     4,   365,     4,     4,     3,     8,   392,   380,   382,
     384,   386,   388,   390,     8,     3,   310,   225,     4,   314,
     312,   317,     4,     8,     3,   332,     4,     4,     8,     3,
     259,   261,     3,     8,     4,   436,   438,     4,   441,     4,
       4,   445,   448,     4,     4,     4,   453,   456,     3,     8,
     168,   168,   150,     4,     4,     4,     4,     4,   187,     4,
       4,     4,   151,   151,   151,   151,   151,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,   151,     4,     4,
     193,     4,   153,   204,    71,   183,   224,   319,   401,   402,
     403,   404,   405,     4,     4,     4,     4,     4,   151,   153,
       4,     4,     4,     4,   281,     4,     4,   346,     4,   151,
       4,   151,   151,   360,     4,     4,     4,     4,     4,     4,
       4,   378,     4,     4,   151,     4,     4,     4,   153,   305,
       4,   153,   153,   329,     4,     4,   257,   153,     4,     4,
     151,     4,   151,   151,     4,     4,   153,   153,   153,     4,
       4,   433,     4,     7,     7,   168,   168,   168,     7,     7,
       7,     5,     5,     5,     5,     5,     5,     5,     5,     7,
       7,     7,     7,     5,   179,   406,     8,     3,     5,     5,
     150,   150,   150,    64,    65,    66,   292,   150,     5,     7,
     150,   170,   172,   150,   150,   179,   179,   179,   150,   150,
     150,   150,   150,   150,   150,   150,   150,   150,   150,   168,
     150,   150,   150,   119,   120,   446,   121,   122,   123,   124,
     125,   153,   454,   150,   168,   192,   127,   465,   466,   467,
     203,    16,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,   183,   212,   213,   214,   217,   219,   221,   223,
     224,   226,   227,   228,   229,   230,   232,   212,     7,   274,
     275,   276,     7,   297,   298,   299,     7,   321,   322,   323,
      76,   150,   236,   237,   238,   239,   177,    77,    79,   238,
     242,   243,   244,   245,   288,   399,     7,   250,   251,   252,
      86,    87,    88,    89,    90,    91,   264,   265,   266,   267,
     268,   269,   270,   271,    16,    96,    97,    98,    99,   183,
     226,   409,   410,   411,   414,   415,   417,   418,   102,   103,
     422,   423,   424,   426,   432,   180,     4,   403,     7,   339,
     340,   341,     7,   353,   354,   355,     7,   370,   371,   372,
      81,   395,     8,   468,     3,     8,     8,   215,   218,   220,
     222,     4,     4,     4,     4,     4,   231,   233,     3,     8,
       8,   277,     6,     3,   300,     6,     3,   324,     6,     3,
       3,     6,     6,     3,     6,     3,     6,   253,     6,     3,
       4,     4,     4,     4,     4,     4,     3,     8,   412,   416,
       4,     4,     4,     3,     8,   425,   427,     3,     8,     8,
     150,   181,   182,   150,   342,     6,     3,   356,     6,     3,
     373,     6,     3,   396,     8,     4,   466,     4,     4,     4,
       4,   151,   153,   151,   153,   151,     4,     4,   213,   280,
     276,   303,   299,   327,   323,   237,   243,   288,   256,   252,
     151,   151,   151,   151,   151,   151,   265,     4,     4,   151,
     151,   151,   410,     4,     4,   423,     6,     3,   345,   341,
     359,   355,   376,   372,     4,     5,    17,    18,    19,    20,
      21,   216,   150,   150,   150,   150,   150,     8,     8,     8,
       8,    93,    94,    95,   413,   150,   150,   150,   150,     8,
       8,     8,   150,     7,   469,   470,   471,     3,     6,   128,
     130,   131,   183,   224,   472,   473,   474,   475,   477,   470,
     478,     4,   476,     3,     8,     4,   151,     4,   473,     5,
     150,     7,   479,   480,   481,     3,     6,   129,   132,   133,
     134,   482,   483,   484,   486,   487,   488,   480,   485,     4,
       4,     4,     3,     8,     4,   153,   151,   151,   483,   150
  };

  const unsigned short int
  Dhcp6Parser::yyr1_[] =
  {
       0,   154,   156,   155,   157,   155,   158,   155,   159,   155,
     160,   155,   161,   155,   162,   155,   163,   155,   164,   155,
     165,   155,   166,   155,   167,   155,   168,   168,   168,   168,
     168,   168,   168,   169,   171,   170,   172,   173,   173,   174,
     174,   176,   175,   177,   177,   178,   178,   180,   179,   181,
     181,   182,   182,   183,   185,   184,   186,   186,   187,   187,
     187,   187,   187,   187,   189,   188,   191,   190,   192,   192,
     193,   193,   193,   193,   193,   193,   193,   193,   193,   193,
     193,   193,   193,   193,   193,   193,   193,   193,   193,   193,
     193,   193,   194,   195,   196,   197,   198,   200,   199,   202,
     201,   203,   203,   204,   204,   206,   205,   207,   209,   208,
     211,   210,   212,   212,   213,   213,   213,   213,   213,   213,
     213,   213,   213,   213,   213,   213,   213,   215,   214,   216,
     216,   216,   216,   216,   218,   217,   220,   219,   222,   221,
     223,   225,   224,   226,   227,   228,   229,   231,   230,   233,
     232,   235,   234,   236,   236,   237,   237,   238,   239,   241,
     240,   242,   242,   243,   243,   243,   244,   245,   247,   246,
     249,   248,   250,   250,   251,   251,   253,   252,   255,   254,
     256,   256,   256,   257,   257,   259,   258,   261,   260,   263,
     262,   264,   264,   265,   265,   265,   265,   265,   265,   266,
     267,   268,   269,   270,   271,   273,   272,   274,   274,   275,
     275,   277,   276,   279,   278,   280,   280,   281,   281,   281,
     281,   281,   281,   281,   281,   281,   281,   281,   281,   281,
     281,   281,   281,   281,   283,   282,   285,   284,   287,   286,
     289,   288,   291,   290,   292,   292,   292,   293,   294,   296,
     295,   297,   297,   298,   298,   300,   299,   302,   301,   303,
     303,   304,   304,   305,   305,   305,   305,   305,   305,   305,
     305,   306,   307,   308,   310,   309,   312,   311,   314,   313,
     315,   317,   316,   318,   320,   319,   321,   321,   322,   322,
     324,   323,   326,   325,   327,   327,   328,   328,   329,   329,
     329,   329,   329,   329,   329,   330,   332,   331,   333,   334,
     335,   336,   338,   337,   339,   339,   340,   340,   342,   341,
     344,   343,   345,   345,   346,   346,   346,   346,   348,   347,
     350,   349,   352,   351,   353,   353,   354,   354,   356,   355,
     358,   357,   359,   359,   360,   360,   360,   360,   360,   360,
     360,   360,   362,   361,   363,   365,   364,   366,   367,   369,
     368,   370,   370,   371,   371,   373,   372,   375,   374,   376,
     376,   377,   377,   378,   378,   378,   378,   378,   378,   378,
     378,   378,   380,   379,   382,   381,   384,   383,   386,   385,
     388,   387,   390,   389,   392,   391,   394,   393,   396,   395,
     398,   397,   399,   399,   400,   288,   401,   401,   402,   402,
     403,   403,   403,   403,   404,   406,   405,   408,   407,   409,
     409,   410,   410,   410,   410,   410,   410,   410,   412,   411,
     413,   413,   413,   414,   416,   415,   417,   418,   419,   421,
     420,   422,   422,   423,   423,   425,   424,   427,   426,   429,
     428,   431,   430,   432,   432,   433,   433,   433,   433,   433,
     433,   433,   433,   433,   433,   433,   433,   433,   433,   433,
     434,   436,   435,   438,   437,   439,   441,   440,   442,   443,
     445,   444,   446,   446,   448,   447,   449,   450,   451,   453,
     452,   454,   454,   454,   454,   454,   456,   455,   458,   457,
     460,   459,   462,   461,   464,   463,   465,   465,   466,   468,
     467,   469,   469,   471,   470,   472,   472,   473,   473,   473,
     473,   473,   474,   476,   475,   478,   477,   479,   479,   481,
     480,   482,   482,   483,   483,   483,   483,   485,   484,   486,
     487,   488
  };

  const unsigned char
  Dhcp6Parser::yyr2_[] =
  {
       0,     2,     0,     3,     0,     3,     0,     3,     0,     3,
       0,     3,     0,     3,     0,     3,     0,     3,     0,     3,
       0,     3,     0,     3,     0,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     0,     4,     1,     0,     1,     3,
       5,     0,     4,     0,     1,     1,     3,     0,     4,     0,
       1,     1,     3,     2,     0,     4,     1,     3,     1,     1,
       1,     1,     1,     1,     0,     6,     0,     4,     1,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     3,     3,     3,     3,     0,     6,     0,
       4,     1,     3,     1,     1,     0,     4,     3,     0,     6,
       0,     6,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     0,     4,     1,
       1,     1,     1,     1,     0,     4,     0,     4,     0,     4,
       3,     0,     4,     3,     3,     3,     3,     0,     4,     0,
       4,     0,     6,     1,     3,     1,     1,     1,     1,     0,
       6,     1,     3,     1,     1,     1,     1,     1,     0,     6,
       0,     6,     0,     1,     1,     3,     0,     4,     0,     4,
       1,     3,     1,     1,     1,     0,     4,     0,     4,     0,
       6,     1,     3,     1,     1,     1,     1,     1,     1,     3,
       3,     3,     3,     3,     3,     0,     6,     0,     1,     1,
       3,     0,     4,     0,     4,     1,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     0,     4,     0,     4,     0,     4,
       0,     4,     0,     4,     1,     1,     1,     3,     3,     0,
       6,     0,     1,     1,     3,     0,     4,     0,     4,     0,
       1,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     0,     4,     0,     4,     0,     4,
       1,     0,     4,     3,     0,     6,     0,     1,     1,     3,
       0,     4,     0,     4,     0,     1,     1,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     4,     1,     1,
       3,     3,     0,     6,     0,     1,     1,     3,     0,     4,
       0,     4,     1,     3,     1,     1,     1,     1,     0,     4,
       0,     4,     0,     6,     0,     1,     1,     3,     0,     4,
       0,     4,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     0,     4,     3,     0,     4,     3,     3,     0,
       6,     0,     1,     1,     3,     0,     4,     0,     4,     0,
       1,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     0,     4,     0,     4,     0,     4,     0,     4,
       0,     4,     0,     4,     0,     4,     0,     6,     0,     4,
       0,     6,     1,     3,     0,     4,     0,     1,     1,     3,
       1,     1,     1,     1,     1,     0,     4,     0,     6,     1,
       3,     1,     1,     1,     1,     1,     1,     1,     0,     4,
       1,     1,     1,     3,     0,     4,     3,     3,     3,     0,
       6,     1,     3,     1,     1,     0,     4,     0,     4,     0,
       6,     0,     4,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     0,     4,     0,     4,     3,     0,     4,     3,     3,
       0,     4,     1,     1,     0,     4,     3,     3,     3,     0,
       4,     1,     1,     1,     1,     1,     0,     4,     0,     4,
       0,     4,     0,     4,     0,     6,     1,     3,     1,     0,
       6,     1,     3,     0,     4,     1,     3,     1,     1,     1,
       1,     1,     3,     0,     4,     0,     6,     1,     3,     0,
       4,     1,     3,     1,     1,     1,     1,     0,     4,     3,
       3,     3
  };



  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a yyntokens_, nonterminals.
  const char*
  const Dhcp6Parser::yytname_[] =
  {
  "\"end of file\"", "error", "$undefined", "\",\"", "\":\"", "\"[\"",
  "\"]\"", "\"{\"", "\"}\"", "\"null\"", "\"Dhcp6\"",
  "\"interfaces-config\"", "\"interfaces\"", "\"re-detect\"",
  "\"lease-database\"", "\"hosts-database\"", "\"type\"", "\"memfile\"",
  "\"mysql\"", "\"postgresql\"", "\"cql\"", "\"radius\"", "\"user\"",
  "\"password\"", "\"host\"", "\"port\"", "\"persist\"",
  "\"lfc-interval\"", "\"readonly\"", "\"connect-timeout\"",
  "\"contact-points\"", "\"keyspace\"", "\"preferred-lifetime\"",
  "\"valid-lifetime\"", "\"renew-timer\"", "\"rebind-timer\"",
  "\"decline-probation-period\"", "\"subnet6\"", "\"option-def\"",
  "\"option-data\"", "\"name\"", "\"data\"", "\"code\"", "\"space\"",
  "\"csv-format\"", "\"always-send\"", "\"record-types\"",
  "\"encapsulate\"", "\"array\"", "\"pools\"", "\"pool\"", "\"pd-pools\"",
  "\"prefix\"", "\"prefix-len\"", "\"excluded-prefix\"",
  "\"excluded-prefix-len\"", "\"delegated-len\"", "\"user-context\"",
  "\"subnet\"", "\"interface\"", "\"interface-id\"", "\"id\"",
  "\"rapid-commit\"", "\"reservation-mode\"", "\"disabled\"",
  "\"out-of-pool\"", "\"all\"", "\"mac-sources\"",
  "\"relay-supplied-options\"", "\"host-reservation-identifiers\"",
  "\"client-classes\"", "\"test\"", "\"client-class\"", "\"reservations\"",
  "\"ip-addresses\"", "\"prefixes\"", "\"duid\"", "\"hw-address\"",
  "\"hostname\"", "\"flex-id\"", "\"relay\"", "\"ip-address\"",
  "\"hooks-libraries\"", "\"library\"", "\"parameters\"",
  "\"expired-leases-processing\"", "\"reclaim-timer-wait-time\"",
  "\"flush-reclaimed-timer-wait-time\"", "\"hold-reclaimed-time\"",
  "\"max-reclaim-leases\"", "\"max-reclaim-time\"",
  "\"unwarned-reclaim-cycles\"", "\"server-id\"", "\"LLT\"", "\"EN\"",
  "\"LL\"", "\"identifier\"", "\"htype\"", "\"time\"", "\"enterprise-id\"",
  "\"dhcp4o6-port\"", "\"control-socket\"", "\"socket-type\"",
  "\"socket-name\"", "\"dhcp-ddns\"", "\"enable-updates\"",
  "\"qualifying-suffix\"", "\"server-ip\"", "\"server-port\"",
  "\"sender-ip\"", "\"sender-port\"", "\"max-queue-size\"",
  "\"ncr-protocol\"", "\"ncr-format\"", "\"always-include-fqdn\"",
  "\"override-no-update\"", "\"override-client-update\"",
  "\"replace-client-name\"", "\"generated-prefix\"", "\"UDP\"", "\"TCP\"",
  "\"JSON\"", "\"when-present\"", "\"never\"", "\"always\"",
  "\"when-not-present\"", "\"Logging\"", "\"loggers\"",
  "\"output_options\"", "\"output\"", "\"debuglevel\"", "\"severity\"",
  "\"flush\"", "\"maxsize\"", "\"maxver\"", "\"Dhcp4\"", "\"DhcpDdns\"",
  "\"Control-agent\"", "TOPLEVEL_JSON", "TOPLEVEL_DHCP6", "SUB_DHCP6",
  "SUB_INTERFACES6", "SUB_SUBNET6", "SUB_POOL6", "SUB_PD_POOL",
  "SUB_RESERVATION", "SUB_OPTION_DEF", "SUB_OPTION_DATA",
  "SUB_HOOKS_LIBRARY", "SUB_DHCP_DDNS", "\"constant string\"",
  "\"integer\"", "\"floating point\"", "\"boolean\"", "$accept", "start",
  "$@1", "$@2", "$@3", "$@4", "$@5", "$@6", "$@7", "$@8", "$@9", "$@10",
  "$@11", "$@12", "value", "sub_json", "map2", "$@13", "map_value",
  "map_content", "not_empty_map", "list_generic", "$@14", "list_content",
  "not_empty_list", "list_strings", "$@15", "list_strings_content",
  "not_empty_list_strings", "unknown_map_entry", "syntax_map", "$@16",
  "global_objects", "global_object", "dhcp6_object", "$@17", "sub_dhcp6",
  "$@18", "global_params", "global_param", "preferred_lifetime",
  "valid_lifetime", "renew_timer", "rebind_timer",
  "decline_probation_period", "interfaces_config", "$@19",
  "sub_interfaces6", "$@20", "interfaces_config_params",
  "interfaces_config_param", "interfaces_list", "$@21", "re_detect",
  "lease_database", "$@22", "hosts_database", "$@23",
  "database_map_params", "database_map_param", "database_type", "$@24",
  "db_type", "user", "$@25", "password", "$@26", "host", "$@27", "port",
  "name", "$@28", "persist", "lfc_interval", "readonly", "connect_timeout",
  "contact_points", "$@29", "keyspace", "$@30", "mac_sources", "$@31",
  "mac_sources_list", "mac_sources_value", "duid_id", "string_id",
  "host_reservation_identifiers", "$@32",
  "host_reservation_identifiers_list", "host_reservation_identifier",
  "hw_address_id", "flex_id", "relay_supplied_options", "$@33",
  "hooks_libraries", "$@34", "hooks_libraries_list",
  "not_empty_hooks_libraries_list", "hooks_library", "$@35",
  "sub_hooks_library", "$@36", "hooks_params", "hooks_param", "library",
  "$@37", "parameters", "$@38", "expired_leases_processing", "$@39",
  "expired_leases_params", "expired_leases_param",
  "reclaim_timer_wait_time", "flush_reclaimed_timer_wait_time",
  "hold_reclaimed_time", "max_reclaim_leases", "max_reclaim_time",
  "unwarned_reclaim_cycles", "subnet6_list", "$@40",
  "subnet6_list_content", "not_empty_subnet6_list", "subnet6", "$@41",
  "sub_subnet6", "$@42", "subnet6_params", "subnet6_param", "subnet",
  "$@43", "interface", "$@44", "interface_id", "$@45", "client_class",
  "$@46", "reservation_mode", "$@47", "hr_mode", "id", "rapid_commit",
  "option_def_list", "$@48", "option_def_list_content",
  "not_empty_option_def_list", "option_def_entry", "$@49",
  "sub_option_def", "$@50", "option_def_params",
  "not_empty_option_def_params", "option_def_param", "option_def_name",
  "code", "option_def_code", "option_def_type", "$@51",
  "option_def_record_types", "$@52", "space", "$@53", "option_def_space",
  "option_def_encapsulate", "$@54", "option_def_array", "option_data_list",
  "$@55", "option_data_list_content", "not_empty_option_data_list",
  "option_data_entry", "$@56", "sub_option_data", "$@57",
  "option_data_params", "not_empty_option_data_params",
  "option_data_param", "option_data_name", "option_data_data", "$@58",
  "option_data_code", "option_data_space", "option_data_csv_format",
  "option_data_always_send", "pools_list", "$@59", "pools_list_content",
  "not_empty_pools_list", "pool_list_entry", "$@60", "sub_pool6", "$@61",
  "pool_params", "pool_param", "pool_entry", "$@62", "user_context",
  "$@63", "pd_pools_list", "$@64", "pd_pools_list_content",
  "not_empty_pd_pools_list", "pd_pool_entry", "$@65", "sub_pd_pool",
  "$@66", "pd_pool_params", "pd_pool_param", "pd_prefix", "$@67",
  "pd_prefix_len", "excluded_prefix", "$@68", "excluded_prefix_len",
  "pd_delegated_len", "reservations", "$@69", "reservations_list",
  "not_empty_reservations_list", "reservation", "$@70", "sub_reservation",
  "$@71", "reservation_params", "not_empty_reservation_params",
  "reservation_param", "ip_addresses", "$@72", "prefixes", "$@73", "duid",
  "$@74", "hw_address", "$@75", "hostname", "$@76", "flex_id_value",
  "$@77", "reservation_client_classes", "$@78", "relay", "$@79",
  "relay_map", "$@80", "client_classes", "$@81", "client_classes_list",
  "$@82", "client_class_params", "not_empty_client_class_params",
  "client_class_param", "client_class_name", "client_class_test", "$@83",
  "server_id", "$@84", "server_id_params", "server_id_param",
  "server_id_type", "$@85", "duid_type", "htype", "identifier", "$@86",
  "time", "enterprise_id", "dhcp4o6_port", "control_socket", "$@87",
  "control_socket_params", "control_socket_param", "socket_type", "$@88",
  "socket_name", "$@89", "dhcp_ddns", "$@90", "sub_dhcp_ddns", "$@91",
  "dhcp_ddns_params", "dhcp_ddns_param", "enable_updates",
  "qualifying_suffix", "$@92", "server_ip", "$@93", "server_port",
  "sender_ip", "$@94", "sender_port", "max_queue_size", "ncr_protocol",
  "$@95", "ncr_protocol_value", "ncr_format", "$@96",
  "always_include_fqdn", "override_no_update", "override_client_update",
  "replace_client_name", "$@97", "replace_client_name_value",
  "generated_prefix", "$@98", "dhcp4_json_object", "$@99",
  "dhcpddns_json_object", "$@100", "control_agent_json_object", "$@101",
  "logging_object", "$@102", "logging_params", "logging_param", "loggers",
  "$@103", "loggers_entries", "logger_entry", "$@104", "logger_params",
  "logger_param", "debuglevel", "severity", "$@105", "output_options_list",
  "$@106", "output_options_list_content", "output_entry", "$@107",
  "output_params_list", "output_params", "output", "$@108", "flush",
  "maxsize", "maxver", YY_NULLPTR
  };

#if PARSER6_DEBUG
  const unsigned short int
  Dhcp6Parser::yyrline_[] =
  {
       0,   235,   235,   235,   236,   236,   237,   237,   238,   238,
     239,   239,   240,   240,   241,   241,   242,   242,   243,   243,
     244,   244,   245,   245,   246,   246,   254,   255,   256,   257,
     258,   259,   260,   263,   268,   268,   279,   282,   283,   286,
     290,   297,   297,   304,   305,   308,   312,   319,   319,   326,
     327,   330,   334,   345,   355,   355,   367,   368,   372,   373,
     374,   375,   376,   377,   380,   380,   397,   397,   405,   406,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   435,   440,   445,   450,   455,   460,   460,   470,
     470,   478,   479,   482,   483,   486,   486,   496,   502,   502,
     512,   512,   522,   523,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   541,   541,   548,
     549,   550,   551,   552,   555,   555,   563,   563,   571,   571,
     579,   584,   584,   592,   597,   602,   607,   612,   612,   620,
     620,   629,   629,   639,   640,   643,   644,   647,   652,   657,
     657,   667,   668,   671,   672,   673,   676,   681,   688,   688,
     698,   698,   708,   709,   712,   713,   716,   716,   724,   724,
     732,   733,   734,   737,   738,   741,   741,   749,   749,   757,
     757,   767,   768,   771,   772,   773,   774,   775,   776,   779,
     784,   789,   794,   799,   804,   812,   812,   825,   826,   829,
     830,   837,   837,   860,   860,   869,   870,   874,   875,   876,
     877,   878,   879,   880,   881,   882,   883,   884,   885,   886,
     887,   888,   889,   890,   893,   893,   901,   901,   909,   909,
     917,   917,   925,   925,   932,   933,   934,   937,   942,   951,
     951,   963,   964,   967,   968,   973,   973,   984,   984,   994,
     995,   998,   999,  1002,  1003,  1004,  1005,  1006,  1007,  1008,
    1009,  1012,  1014,  1019,  1021,  1021,  1029,  1029,  1037,  1037,
    1045,  1047,  1047,  1055,  1064,  1064,  1076,  1077,  1082,  1083,
    1088,  1088,  1099,  1099,  1110,  1111,  1116,  1117,  1122,  1123,
    1124,  1125,  1126,  1127,  1128,  1131,  1133,  1133,  1141,  1143,
    1145,  1150,  1158,  1158,  1170,  1171,  1174,  1175,  1178,  1178,
    1186,  1186,  1194,  1195,  1198,  1199,  1200,  1201,  1204,  1204,
    1212,  1212,  1222,  1222,  1234,  1235,  1238,  1239,  1242,  1242,
    1250,  1250,  1258,  1259,  1262,  1263,  1264,  1265,  1266,  1267,
    1268,  1269,  1272,  1272,  1280,  1285,  1285,  1293,  1298,  1306,
    1306,  1316,  1317,  1320,  1321,  1324,  1324,  1332,  1332,  1340,
    1341,  1344,  1345,  1349,  1350,  1351,  1352,  1353,  1354,  1355,
    1356,  1357,  1360,  1360,  1370,  1370,  1380,  1380,  1388,  1388,
    1396,  1396,  1404,  1404,  1412,  1412,  1425,  1425,  1435,  1435,
    1446,  1446,  1456,  1457,  1460,  1460,  1468,  1469,  1472,  1473,
    1476,  1477,  1478,  1479,  1482,  1484,  1484,  1495,  1495,  1505,
    1506,  1509,  1510,  1511,  1512,  1513,  1514,  1515,  1518,  1518,
    1525,  1526,  1527,  1530,  1535,  1535,  1543,  1548,  1555,  1562,
    1562,  1572,  1573,  1576,  1577,  1580,  1580,  1588,  1588,  1598,
    1598,  1608,  1608,  1616,  1617,  1620,  1621,  1622,  1623,  1624,
    1625,  1626,  1627,  1628,  1629,  1630,  1631,  1632,  1633,  1634,
    1637,  1642,  1642,  1650,  1650,  1658,  1663,  1663,  1671,  1676,
    1681,  1681,  1689,  1690,  1693,  1693,  1701,  1706,  1711,  1716,
    1716,  1724,  1727,  1730,  1733,  1736,  1742,  1742,  1752,  1752,
    1759,  1759,  1766,  1766,  1779,  1779,  1792,  1793,  1797,  1801,
    1801,  1813,  1814,  1818,  1818,  1826,  1827,  1830,  1831,  1832,
    1833,  1834,  1837,  1842,  1842,  1850,  1850,  1860,  1861,  1864,
    1864,  1872,  1873,  1876,  1877,  1878,  1879,  1882,  1882,  1890,
    1895,  1900
  };

  // Print the state stack on the debug stream.
  void
  Dhcp6Parser::yystack_print_ ()
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << i->state;
    *yycdebug_ << std::endl;
  }

  // Report on the debug stream that the rule \a yyrule is going to be reduced.
  void
  Dhcp6Parser::yy_reduce_print_ (int yyrule)
  {
    unsigned int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):" << std::endl;
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // PARSER6_DEBUG


#line 14 "dhcp6_parser.yy" // lalr1.cc:1167
} } // isc::dhcp
#line 4332 "dhcp6_parser.cc" // lalr1.cc:1167
#line 1905 "dhcp6_parser.yy" // lalr1.cc:1168


void
isc::dhcp::Dhcp6Parser::error(const location_type& loc,
                              const std::string& what)
{
    ctx.error(loc, what);
}
